/* daemon_interface.c generated by valac 0.56.12, the Vala compiler
 * generated from daemon_interface.vala, do not modify */

/*
 *  pamac-vala
 *
 *  Copyright (C) 2019-2023 Guillaume Benoit <guillaume@manjaro.org>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a get of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include "pamac.h"

#define PAMAC_TYPE_DAEMON (pamac_daemon_get_type ())
#define PAMAC_DAEMON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PAMAC_TYPE_DAEMON, PamacDaemon))
#define PAMAC_IS_DAEMON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PAMAC_TYPE_DAEMON))
#define PAMAC_DAEMON_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), PAMAC_TYPE_DAEMON, PamacDaemonIface))

typedef struct _PamacDaemon PamacDaemon;
typedef struct _PamacDaemonIface PamacDaemonIface;

#define PAMAC_TYPE_DAEMON_PROXY (pamac_daemon_proxy_get_type ())
enum  {
	PAMAC_DAEMON_EMIT_ACTION_SIGNAL,
	PAMAC_DAEMON_EMIT_ACTION_PROGRESS_SIGNAL,
	PAMAC_DAEMON_EMIT_DOWNLOAD_PROGRESS_SIGNAL,
	PAMAC_DAEMON_EMIT_HOOK_PROGRESS_SIGNAL,
	PAMAC_DAEMON_EMIT_SCRIPT_OUTPUT_SIGNAL,
	PAMAC_DAEMON_EMIT_WARNING_SIGNAL,
	PAMAC_DAEMON_EMIT_ERROR_SIGNAL,
	PAMAC_DAEMON_IMPORTANT_DETAILS_OUTPOUT_SIGNAL,
	PAMAC_DAEMON_START_DOWNLOADING_SIGNAL,
	PAMAC_DAEMON_STOP_DOWNLOADING_SIGNAL,
	PAMAC_DAEMON_SET_PKGREASON_FINISHED_SIGNAL,
	PAMAC_DAEMON_START_WAITING_SIGNAL,
	PAMAC_DAEMON_STOP_WAITING_SIGNAL,
	PAMAC_DAEMON_DOWNLOAD_PKG_FINISHED_SIGNAL,
	PAMAC_DAEMON_TRANS_REFRESH_FINISHED_SIGNAL,
	PAMAC_DAEMON_TRANS_RUN_FINISHED_SIGNAL,
	PAMAC_DAEMON_DOWNLOAD_UPDATES_FINISHED_SIGNAL,
	PAMAC_DAEMON_GET_AUTHORIZATION_FINISHED_SIGNAL,
	PAMAC_DAEMON_WRITE_ALPM_CONFIG_FINISHED_SIGNAL,
	PAMAC_DAEMON_WRITE_PAMAC_CONFIG_FINISHED_SIGNAL,
	PAMAC_DAEMON_GENERATE_MIRRORS_LIST_DATA_SIGNAL,
	PAMAC_DAEMON_GENERATE_MIRRORS_LIST_FINISHED_SIGNAL,
	PAMAC_DAEMON_CLEAN_CACHE_FINISHED_SIGNAL,
	PAMAC_DAEMON_CLEAN_BUILD_FILES_FINISHED_SIGNAL,
	PAMAC_DAEMON_SNAP_TRANS_RUN_FINISHED_SIGNAL,
	PAMAC_DAEMON_SNAP_SWITCH_CHANNEL_FINISHED_SIGNAL,
	PAMAC_DAEMON_FLATPAK_TRANS_RUN_FINISHED_SIGNAL,
	PAMAC_DAEMON_NUM_SIGNALS
};
static guint pamac_daemon_signals[PAMAC_DAEMON_NUM_SIGNALS] = {0};
typedef GDBusProxy PamacDaemonProxy;
typedef GDBusProxyClass PamacDaemonProxyClass;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))

struct _PamacDaemonIface {
	GTypeInterface parent_iface;
	gchar* (*get_sender) (PamacDaemon* self, GError** error);
	gchar* (*get_lockfile) (PamacDaemon* self, GError** error);
	void (*set_environment_variables) (PamacDaemon* self, GHashTable* variables, GError** error);
	void (*start_get_authorization) (PamacDaemon* self, GError** error);
	void (*remove_authorization) (PamacDaemon* self, GError** error);
	void (*start_write_alpm_config) (PamacDaemon* self, GHashTable* new_alpm_conf, GError** error);
	void (*start_write_pamac_config) (PamacDaemon* self, GHashTable* new_pamac_conf, GError** error);
	void (*start_generate_mirrors_list) (PamacDaemon* self, const gchar* country, GError** error);
	void (*start_clean_cache) (PamacDaemon* self, gchar** filenames, gint filenames_length1, GError** error);
	void (*start_clean_build_files) (PamacDaemon* self, const gchar* aur_build_dir, GError** error);
	void (*start_set_pkgreason) (PamacDaemon* self, const gchar* pkgname, guint reason, GError** error);
	void (*start_download_updates) (PamacDaemon* self, GError** error);
	void (*start_download_pkg) (PamacDaemon* self, const gchar* url, GError** error);
	void (*start_trans_refresh) (PamacDaemon* self, gboolean force, GError** error);
	void (*start_trans_run) (PamacDaemon* self, gboolean sysupgrade, gboolean enable_downgrade, gboolean simple_install, gboolean keep_built_pkgs, gint trans_flags, gchar** to_install, gint to_install_length1, gchar** to_remove, gint to_remove_length1, gchar** to_load, gint to_load_length1, gchar** to_install_as_dep, gint to_install_as_dep_length1, gchar** ignorepkgs, gint ignorepkgs_length1, gchar** overwrite_files, gint overwrite_files_length1, GError** error);
	void (*trans_cancel) (PamacDaemon* self, GError** error);
	void (*quit) (PamacDaemon* self, GError** error);
	void (*start_snap_trans_run) (PamacDaemon* self, gchar** to_install, gint to_install_length1, gchar** to_remove, gint to_remove_length1, GError** error);
	void (*start_snap_switch_channel) (PamacDaemon* self, const gchar* snap_name, const gchar* channel, GError** error);
	void (*start_flatpak_trans_run) (PamacDaemon* self, gchar** to_install, gint to_install_length1, gchar** to_remove, gint to_remove_length1, gchar** to_upgrade, gint to_upgrade_length1, GError** error);
};

VALA_EXTERN GType pamac_daemon_proxy_get_type (void) G_GNUC_CONST ;
VALA_EXTERN guint pamac_daemon_register_object (void* object,
                                    GDBusConnection* connection,
                                    const gchar* path,
                                    GError** error);
VALA_EXTERN GType pamac_daemon_get_type (void) G_GNUC_CONST ;
VALA_EXTERN gchar* pamac_daemon_get_sender (PamacDaemon* self,
                                GError** error);
VALA_EXTERN gchar* pamac_daemon_get_lockfile (PamacDaemon* self,
                                  GError** error);
VALA_EXTERN void pamac_daemon_set_environment_variables (PamacDaemon* self,
                                             GHashTable* variables,
                                             GError** error);
VALA_EXTERN void pamac_daemon_start_get_authorization (PamacDaemon* self,
                                           GError** error);
VALA_EXTERN void pamac_daemon_remove_authorization (PamacDaemon* self,
                                        GError** error);
VALA_EXTERN void pamac_daemon_start_write_alpm_config (PamacDaemon* self,
                                           GHashTable* new_alpm_conf,
                                           GError** error);
VALA_EXTERN void pamac_daemon_start_write_pamac_config (PamacDaemon* self,
                                            GHashTable* new_pamac_conf,
                                            GError** error);
VALA_EXTERN void pamac_daemon_start_generate_mirrors_list (PamacDaemon* self,
                                               const gchar* country,
                                               GError** error);
VALA_EXTERN void pamac_daemon_start_clean_cache (PamacDaemon* self,
                                     gchar** filenames,
                                     gint filenames_length1,
                                     GError** error);
VALA_EXTERN void pamac_daemon_start_clean_build_files (PamacDaemon* self,
                                           const gchar* aur_build_dir,
                                           GError** error);
VALA_EXTERN void pamac_daemon_start_set_pkgreason (PamacDaemon* self,
                                       const gchar* pkgname,
                                       guint reason,
                                       GError** error);
VALA_EXTERN void pamac_daemon_start_download_updates (PamacDaemon* self,
                                          GError** error);
VALA_EXTERN void pamac_daemon_start_download_pkg (PamacDaemon* self,
                                      const gchar* url,
                                      GError** error);
VALA_EXTERN void pamac_daemon_start_trans_refresh (PamacDaemon* self,
                                       gboolean force,
                                       GError** error);
VALA_EXTERN void pamac_daemon_start_trans_run (PamacDaemon* self,
                                   gboolean sysupgrade,
                                   gboolean enable_downgrade,
                                   gboolean simple_install,
                                   gboolean keep_built_pkgs,
                                   gint trans_flags,
                                   gchar** to_install,
                                   gint to_install_length1,
                                   gchar** to_remove,
                                   gint to_remove_length1,
                                   gchar** to_load,
                                   gint to_load_length1,
                                   gchar** to_install_as_dep,
                                   gint to_install_as_dep_length1,
                                   gchar** ignorepkgs,
                                   gint ignorepkgs_length1,
                                   gchar** overwrite_files,
                                   gint overwrite_files_length1,
                                   GError** error);
VALA_EXTERN void pamac_daemon_trans_cancel (PamacDaemon* self,
                                GError** error);
VALA_EXTERN void pamac_daemon_quit (PamacDaemon* self,
                        GError** error);
VALA_EXTERN void pamac_daemon_start_snap_trans_run (PamacDaemon* self,
                                        gchar** to_install,
                                        gint to_install_length1,
                                        gchar** to_remove,
                                        gint to_remove_length1,
                                        GError** error);
VALA_EXTERN void pamac_daemon_start_snap_switch_channel (PamacDaemon* self,
                                             const gchar* snap_name,
                                             const gchar* channel,
                                             GError** error);
VALA_EXTERN void pamac_daemon_start_flatpak_trans_run (PamacDaemon* self,
                                           gchar** to_install,
                                           gint to_install_length1,
                                           gchar** to_remove,
                                           gint to_remove_length1,
                                           gchar** to_upgrade,
                                           gint to_upgrade_length1,
                                           GError** error);
static void g_cclosure_user_marshal_VOID__STRING_STRING (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__STRING_STRING_STRING_DOUBLE (GClosure * closure,
                                                                GValue * return_value,
                                                                guint n_param_values,
                                                                const GValue * param_values,
                                                                gpointer invocation_hint,
                                                                gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__STRING_STRING_STRING_STRING_DOUBLE (GClosure * closure,
                                                                       GValue * return_value,
                                                                       guint n_param_values,
                                                                       const GValue * param_values,
                                                                       gpointer invocation_hint,
                                                                       gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__STRING_STRING_BOXED_INT (GClosure * closure,
                                                            GValue * return_value,
                                                            guint n_param_values,
                                                            const GValue * param_values,
                                                            gpointer invocation_hint,
                                                            gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__STRING_BOOLEAN (GClosure * closure,
                                                   GValue * return_value,
                                                   guint n_param_values,
                                                   const GValue * param_values,
                                                   gpointer invocation_hint,
                                                   gpointer marshal_data);
static GType pamac_daemon_get_type_once (void);
static void pamac_daemon_proxy_g_signal (GDBusProxy* proxy,
                                  const gchar* sender_name,
                                  const gchar* signal_name,
                                  GVariant* parameters);
static void _dbus_handle_pamac_daemon_emit_action (PamacDaemon* self,
                                            GVariant* parameters);
static void _dbus_handle_pamac_daemon_emit_action_progress (PamacDaemon* self,
                                                     GVariant* parameters);
static void _dbus_handle_pamac_daemon_emit_download_progress (PamacDaemon* self,
                                                       GVariant* parameters);
static void _dbus_handle_pamac_daemon_emit_hook_progress (PamacDaemon* self,
                                                   GVariant* parameters);
static void _dbus_handle_pamac_daemon_emit_script_output (PamacDaemon* self,
                                                   GVariant* parameters);
static void _dbus_handle_pamac_daemon_emit_warning (PamacDaemon* self,
                                             GVariant* parameters);
static void _dbus_handle_pamac_daemon_emit_error (PamacDaemon* self,
                                           GVariant* parameters);
static void _dbus_handle_pamac_daemon_important_details_outpout (PamacDaemon* self,
                                                          GVariant* parameters);
static void _dbus_handle_pamac_daemon_start_downloading (PamacDaemon* self,
                                                  GVariant* parameters);
static void _dbus_handle_pamac_daemon_stop_downloading (PamacDaemon* self,
                                                 GVariant* parameters);
static void _dbus_handle_pamac_daemon_set_pkgreason_finished (PamacDaemon* self,
                                                       GVariant* parameters);
static void _dbus_handle_pamac_daemon_start_waiting (PamacDaemon* self,
                                              GVariant* parameters);
static void _dbus_handle_pamac_daemon_stop_waiting (PamacDaemon* self,
                                             GVariant* parameters);
static void _dbus_handle_pamac_daemon_download_pkg_finished (PamacDaemon* self,
                                                      GVariant* parameters);
static void _dbus_handle_pamac_daemon_trans_refresh_finished (PamacDaemon* self,
                                                       GVariant* parameters);
static void _dbus_handle_pamac_daemon_trans_run_finished (PamacDaemon* self,
                                                   GVariant* parameters);
static void _dbus_handle_pamac_daemon_download_updates_finished (PamacDaemon* self,
                                                          GVariant* parameters);
static void _dbus_handle_pamac_daemon_get_authorization_finished (PamacDaemon* self,
                                                           GVariant* parameters);
static void _dbus_handle_pamac_daemon_write_alpm_config_finished (PamacDaemon* self,
                                                           GVariant* parameters);
static void _dbus_handle_pamac_daemon_write_pamac_config_finished (PamacDaemon* self,
                                                            GVariant* parameters);
static void _dbus_handle_pamac_daemon_generate_mirrors_list_data (PamacDaemon* self,
                                                           GVariant* parameters);
static void _dbus_handle_pamac_daemon_generate_mirrors_list_finished (PamacDaemon* self,
                                                               GVariant* parameters);
static void _dbus_handle_pamac_daemon_clean_cache_finished (PamacDaemon* self,
                                                     GVariant* parameters);
static void _dbus_handle_pamac_daemon_clean_build_files_finished (PamacDaemon* self,
                                                           GVariant* parameters);
static void _dbus_handle_pamac_daemon_snap_trans_run_finished (PamacDaemon* self,
                                                        GVariant* parameters);
static void _dbus_handle_pamac_daemon_snap_switch_channel_finished (PamacDaemon* self,
                                                             GVariant* parameters);
static void _dbus_handle_pamac_daemon_flatpak_trans_run_finished (PamacDaemon* self,
                                                           GVariant* parameters);
static gchar* pamac_daemon_proxy_get_sender (PamacDaemon* self,
                                      GError** error);
static gchar* pamac_daemon_proxy_get_lockfile (PamacDaemon* self,
                                        GError** error);
static void pamac_daemon_proxy_set_environment_variables (PamacDaemon* self,
                                                   GHashTable* variables,
                                                   GError** error);
static void pamac_daemon_proxy_start_get_authorization (PamacDaemon* self,
                                                 GError** error);
static void pamac_daemon_proxy_remove_authorization (PamacDaemon* self,
                                              GError** error);
static void pamac_daemon_proxy_start_write_alpm_config (PamacDaemon* self,
                                                 GHashTable* new_alpm_conf,
                                                 GError** error);
static void pamac_daemon_proxy_start_write_pamac_config (PamacDaemon* self,
                                                  GHashTable* new_pamac_conf,
                                                  GError** error);
static void pamac_daemon_proxy_start_generate_mirrors_list (PamacDaemon* self,
                                                     const gchar* country,
                                                     GError** error);
static void pamac_daemon_proxy_start_clean_cache (PamacDaemon* self,
                                           gchar** filenames,
                                           gint filenames_length1,
                                           GError** error);
static void pamac_daemon_proxy_start_clean_build_files (PamacDaemon* self,
                                                 const gchar* aur_build_dir,
                                                 GError** error);
static void pamac_daemon_proxy_start_set_pkgreason (PamacDaemon* self,
                                             const gchar* pkgname,
                                             guint reason,
                                             GError** error);
static void pamac_daemon_proxy_start_download_updates (PamacDaemon* self,
                                                GError** error);
static void pamac_daemon_proxy_start_download_pkg (PamacDaemon* self,
                                            const gchar* url,
                                            GError** error);
static void pamac_daemon_proxy_start_trans_refresh (PamacDaemon* self,
                                             gboolean force,
                                             GError** error);
static void pamac_daemon_proxy_start_trans_run (PamacDaemon* self,
                                         gboolean sysupgrade,
                                         gboolean enable_downgrade,
                                         gboolean simple_install,
                                         gboolean keep_built_pkgs,
                                         gint trans_flags,
                                         gchar** to_install,
                                         gint to_install_length1,
                                         gchar** to_remove,
                                         gint to_remove_length1,
                                         gchar** to_load,
                                         gint to_load_length1,
                                         gchar** to_install_as_dep,
                                         gint to_install_as_dep_length1,
                                         gchar** ignorepkgs,
                                         gint ignorepkgs_length1,
                                         gchar** overwrite_files,
                                         gint overwrite_files_length1,
                                         GError** error);
static void pamac_daemon_proxy_trans_cancel (PamacDaemon* self,
                                      GError** error);
static void pamac_daemon_proxy_quit (PamacDaemon* self,
                              GError** error);
static void pamac_daemon_proxy_start_snap_trans_run (PamacDaemon* self,
                                              gchar** to_install,
                                              gint to_install_length1,
                                              gchar** to_remove,
                                              gint to_remove_length1,
                                              GError** error);
static void pamac_daemon_proxy_start_snap_switch_channel (PamacDaemon* self,
                                                   const gchar* snap_name,
                                                   const gchar* channel,
                                                   GError** error);
static void pamac_daemon_proxy_start_flatpak_trans_run (PamacDaemon* self,
                                                 gchar** to_install,
                                                 gint to_install_length1,
                                                 gchar** to_remove,
                                                 gint to_remove_length1,
                                                 gchar** to_upgrade,
                                                 gint to_upgrade_length1,
                                                 GError** error);
static void pamac_daemon_proxy_pamac_daemon_interface_init (PamacDaemonIface* iface);
static void _dbus_pamac_daemon_get_sender (PamacDaemon* self,
                                    GVariant* _parameters_,
                                    GDBusMethodInvocation* invocation);
static void _dbus_pamac_daemon_get_lockfile (PamacDaemon* self,
                                      GVariant* _parameters_,
                                      GDBusMethodInvocation* invocation);
static void _dbus_pamac_daemon_set_environment_variables (PamacDaemon* self,
                                                   GVariant* _parameters_,
                                                   GDBusMethodInvocation* invocation);
static void _dbus_pamac_daemon_start_get_authorization (PamacDaemon* self,
                                                 GVariant* _parameters_,
                                                 GDBusMethodInvocation* invocation);
static void _dbus_pamac_daemon_remove_authorization (PamacDaemon* self,
                                              GVariant* _parameters_,
                                              GDBusMethodInvocation* invocation);
static void _dbus_pamac_daemon_start_write_alpm_config (PamacDaemon* self,
                                                 GVariant* _parameters_,
                                                 GDBusMethodInvocation* invocation);
static void _dbus_pamac_daemon_start_write_pamac_config (PamacDaemon* self,
                                                  GVariant* _parameters_,
                                                  GDBusMethodInvocation* invocation);
static void _dbus_pamac_daemon_start_generate_mirrors_list (PamacDaemon* self,
                                                     GVariant* _parameters_,
                                                     GDBusMethodInvocation* invocation);
static void _dbus_pamac_daemon_start_clean_cache (PamacDaemon* self,
                                           GVariant* _parameters_,
                                           GDBusMethodInvocation* invocation);
static void _dbus_pamac_daemon_start_clean_build_files (PamacDaemon* self,
                                                 GVariant* _parameters_,
                                                 GDBusMethodInvocation* invocation);
static void _dbus_pamac_daemon_start_set_pkgreason (PamacDaemon* self,
                                             GVariant* _parameters_,
                                             GDBusMethodInvocation* invocation);
static void _dbus_pamac_daemon_start_download_updates (PamacDaemon* self,
                                                GVariant* _parameters_,
                                                GDBusMethodInvocation* invocation);
static void _dbus_pamac_daemon_start_download_pkg (PamacDaemon* self,
                                            GVariant* _parameters_,
                                            GDBusMethodInvocation* invocation);
static void _dbus_pamac_daemon_start_trans_refresh (PamacDaemon* self,
                                             GVariant* _parameters_,
                                             GDBusMethodInvocation* invocation);
static void _dbus_pamac_daemon_start_trans_run (PamacDaemon* self,
                                         GVariant* _parameters_,
                                         GDBusMethodInvocation* invocation);
static void _dbus_pamac_daemon_trans_cancel (PamacDaemon* self,
                                      GVariant* _parameters_,
                                      GDBusMethodInvocation* invocation);
static void _dbus_pamac_daemon_quit (PamacDaemon* self,
                              GVariant* _parameters_,
                              GDBusMethodInvocation* invocation);
static void _dbus_pamac_daemon_start_snap_trans_run (PamacDaemon* self,
                                              GVariant* _parameters_,
                                              GDBusMethodInvocation* invocation);
static void _dbus_pamac_daemon_start_snap_switch_channel (PamacDaemon* self,
                                                   GVariant* _parameters_,
                                                   GDBusMethodInvocation* invocation);
static void _dbus_pamac_daemon_start_flatpak_trans_run (PamacDaemon* self,
                                                 GVariant* _parameters_,
                                                 GDBusMethodInvocation* invocation);
static void pamac_daemon_dbus_interface_method_call (GDBusConnection* connection,
                                              const gchar* sender,
                                              const gchar* object_path,
                                              const gchar* interface_name,
                                              const gchar* method_name,
                                              GVariant* parameters,
                                              GDBusMethodInvocation* invocation,
                                              gpointer user_data);
static GVariant* pamac_daemon_dbus_interface_get_property (GDBusConnection* connection,
                                                    const gchar* sender,
                                                    const gchar* object_path,
                                                    const gchar* interface_name,
                                                    const gchar* property_name,
                                                    GError** error,
                                                    gpointer user_data);
static gboolean pamac_daemon_dbus_interface_set_property (GDBusConnection* connection,
                                                   const gchar* sender,
                                                   const gchar* object_path,
                                                   const gchar* interface_name,
                                                   const gchar* property_name,
                                                   GVariant* value,
                                                   GError** error,
                                                   gpointer user_data);
static void _dbus_pamac_daemon_emit_action (GObject* _sender,
                                     const gchar* sender,
                                     const gchar* action,
                                     gpointer* _data);
static void _dbus_pamac_daemon_emit_action_progress (GObject* _sender,
                                              const gchar* sender,
                                              const gchar* action,
                                              const gchar* status,
                                              gdouble progress,
                                              gpointer* _data);
static void _dbus_pamac_daemon_emit_download_progress (GObject* _sender,
                                                const gchar* sender,
                                                const gchar* action,
                                                const gchar* status,
                                                gdouble progress,
                                                gpointer* _data);
static void _dbus_pamac_daemon_emit_hook_progress (GObject* _sender,
                                            const gchar* sender,
                                            const gchar* action,
                                            const gchar* details,
                                            const gchar* status,
                                            gdouble progress,
                                            gpointer* _data);
static void _dbus_pamac_daemon_emit_script_output (GObject* _sender,
                                            const gchar* sender,
                                            const gchar* message,
                                            gpointer* _data);
static void _dbus_pamac_daemon_emit_warning (GObject* _sender,
                                      const gchar* sender,
                                      const gchar* message,
                                      gpointer* _data);
static void _dbus_pamac_daemon_emit_error (GObject* _sender,
                                    const gchar* sender,
                                    const gchar* message,
                                    gchar** details,
                                    gint details_length1,
                                    gpointer* _data);
static void _dbus_pamac_daemon_important_details_outpout (GObject* _sender,
                                                   const gchar* sender,
                                                   gboolean must_show,
                                                   gpointer* _data);
static void _dbus_pamac_daemon_start_downloading (GObject* _sender,
                                           const gchar* sender,
                                           gpointer* _data);
static void _dbus_pamac_daemon_stop_downloading (GObject* _sender,
                                          const gchar* sender,
                                          gpointer* _data);
static void _dbus_pamac_daemon_set_pkgreason_finished (GObject* _sender,
                                                const gchar* sender,
                                                gboolean success,
                                                gpointer* _data);
static void _dbus_pamac_daemon_start_waiting (GObject* _sender,
                                       const gchar* sender,
                                       gpointer* _data);
static void _dbus_pamac_daemon_stop_waiting (GObject* _sender,
                                      const gchar* sender,
                                      gpointer* _data);
static void _dbus_pamac_daemon_download_pkg_finished (GObject* _sender,
                                               const gchar* sender,
                                               const gchar* path,
                                               gpointer* _data);
static void _dbus_pamac_daemon_trans_refresh_finished (GObject* _sender,
                                                const gchar* sender,
                                                gboolean success,
                                                gpointer* _data);
static void _dbus_pamac_daemon_trans_run_finished (GObject* _sender,
                                            const gchar* sender,
                                            gboolean success,
                                            gpointer* _data);
static void _dbus_pamac_daemon_download_updates_finished (GObject* _sender,
                                                   const gchar* sender,
                                                   gboolean success,
                                                   gpointer* _data);
static void _dbus_pamac_daemon_get_authorization_finished (GObject* _sender,
                                                    const gchar* sender,
                                                    gboolean authorized,
                                                    gpointer* _data);
static void _dbus_pamac_daemon_write_alpm_config_finished (GObject* _sender,
                                                    const gchar* sender,
                                                    gpointer* _data);
static void _dbus_pamac_daemon_write_pamac_config_finished (GObject* _sender,
                                                     const gchar* sender,
                                                     gpointer* _data);
static void _dbus_pamac_daemon_generate_mirrors_list_data (GObject* _sender,
                                                    const gchar* sender,
                                                    const gchar* line,
                                                    gpointer* _data);
static void _dbus_pamac_daemon_generate_mirrors_list_finished (GObject* _sender,
                                                        const gchar* sender,
                                                        gpointer* _data);
static void _dbus_pamac_daemon_clean_cache_finished (GObject* _sender,
                                              const gchar* sender,
                                              gboolean success,
                                              gpointer* _data);
static void _dbus_pamac_daemon_clean_build_files_finished (GObject* _sender,
                                                    const gchar* sender,
                                                    gboolean success,
                                                    gpointer* _data);
static void _dbus_pamac_daemon_snap_trans_run_finished (GObject* _sender,
                                                 const gchar* sender,
                                                 gboolean success,
                                                 gpointer* _data);
static void _dbus_pamac_daemon_snap_switch_channel_finished (GObject* _sender,
                                                      const gchar* sender,
                                                      gboolean success,
                                                      gpointer* _data);
static void _dbus_pamac_daemon_flatpak_trans_run_finished (GObject* _sender,
                                                    const gchar* sender,
                                                    gboolean success,
                                                    gpointer* _data);
static void _pamac_daemon_unregister_object (gpointer user_data);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static const GDBusArgInfo _pamac_daemon_dbus_arg_info_get_sender_result = {-1, "result", "s", NULL};
static const GDBusArgInfo * const _pamac_daemon_dbus_arg_info_get_sender_in[] = {NULL};
static const GDBusArgInfo * const _pamac_daemon_dbus_arg_info_get_sender_out[] = {&_pamac_daemon_dbus_arg_info_get_sender_result, NULL};
static const GDBusMethodInfo _pamac_daemon_dbus_method_info_get_sender = {-1, "GetSender", (GDBusArgInfo **) (&_pamac_daemon_dbus_arg_info_get_sender_in), (GDBusArgInfo **) (&_pamac_daemon_dbus_arg_info_get_sender_out), NULL};
static const GDBusArgInfo _pamac_daemon_dbus_arg_info_get_lockfile_result = {-1, "result", "s", NULL};
static const GDBusArgInfo * const _pamac_daemon_dbus_arg_info_get_lockfile_in[] = {NULL};
static const GDBusArgInfo * const _pamac_daemon_dbus_arg_info_get_lockfile_out[] = {&_pamac_daemon_dbus_arg_info_get_lockfile_result, NULL};
static const GDBusMethodInfo _pamac_daemon_dbus_method_info_get_lockfile = {-1, "GetLockfile", (GDBusArgInfo **) (&_pamac_daemon_dbus_arg_info_get_lockfile_in), (GDBusArgInfo **) (&_pamac_daemon_dbus_arg_info_get_lockfile_out), NULL};
static const GDBusArgInfo _pamac_daemon_dbus_arg_info_set_environment_variables_variables = {-1, "variables", "a{ss}", NULL};
static const GDBusArgInfo * const _pamac_daemon_dbus_arg_info_set_environment_variables_in[] = {&_pamac_daemon_dbus_arg_info_set_environment_variables_variables, NULL};
static const GDBusArgInfo * const _pamac_daemon_dbus_arg_info_set_environment_variables_out[] = {NULL};
static const GDBusMethodInfo _pamac_daemon_dbus_method_info_set_environment_variables = {-1, "SetEnvironmentVariables", (GDBusArgInfo **) (&_pamac_daemon_dbus_arg_info_set_environment_variables_in), (GDBusArgInfo **) (&_pamac_daemon_dbus_arg_info_set_environment_variables_out), NULL};
static const GDBusArgInfo * const _pamac_daemon_dbus_arg_info_start_get_authorization_in[] = {NULL};
static const GDBusArgInfo * const _pamac_daemon_dbus_arg_info_start_get_authorization_out[] = {NULL};
static const GDBusMethodInfo _pamac_daemon_dbus_method_info_start_get_authorization = {-1, "StartGetAuthorization", (GDBusArgInfo **) (&_pamac_daemon_dbus_arg_info_start_get_authorization_in), (GDBusArgInfo **) (&_pamac_daemon_dbus_arg_info_start_get_authorization_out), NULL};
static const GDBusArgInfo * const _pamac_daemon_dbus_arg_info_remove_authorization_in[] = {NULL};
static const GDBusArgInfo * const _pamac_daemon_dbus_arg_info_remove_authorization_out[] = {NULL};
static const GDBusMethodInfo _pamac_daemon_dbus_method_info_remove_authorization = {-1, "RemoveAuthorization", (GDBusArgInfo **) (&_pamac_daemon_dbus_arg_info_remove_authorization_in), (GDBusArgInfo **) (&_pamac_daemon_dbus_arg_info_remove_authorization_out), NULL};
static const GDBusArgInfo _pamac_daemon_dbus_arg_info_start_write_alpm_config_new_alpm_conf = {-1, "new_alpm_conf", "a{sv}", NULL};
static const GDBusArgInfo * const _pamac_daemon_dbus_arg_info_start_write_alpm_config_in[] = {&_pamac_daemon_dbus_arg_info_start_write_alpm_config_new_alpm_conf, NULL};
static const GDBusArgInfo * const _pamac_daemon_dbus_arg_info_start_write_alpm_config_out[] = {NULL};
static const GDBusMethodInfo _pamac_daemon_dbus_method_info_start_write_alpm_config = {-1, "StartWriteAlpmConfig", (GDBusArgInfo **) (&_pamac_daemon_dbus_arg_info_start_write_alpm_config_in), (GDBusArgInfo **) (&_pamac_daemon_dbus_arg_info_start_write_alpm_config_out), NULL};
static const GDBusArgInfo _pamac_daemon_dbus_arg_info_start_write_pamac_config_new_pamac_conf = {-1, "new_pamac_conf", "a{sv}", NULL};
static const GDBusArgInfo * const _pamac_daemon_dbus_arg_info_start_write_pamac_config_in[] = {&_pamac_daemon_dbus_arg_info_start_write_pamac_config_new_pamac_conf, NULL};
static const GDBusArgInfo * const _pamac_daemon_dbus_arg_info_start_write_pamac_config_out[] = {NULL};
static const GDBusMethodInfo _pamac_daemon_dbus_method_info_start_write_pamac_config = {-1, "StartWritePamacConfig", (GDBusArgInfo **) (&_pamac_daemon_dbus_arg_info_start_write_pamac_config_in), (GDBusArgInfo **) (&_pamac_daemon_dbus_arg_info_start_write_pamac_config_out), NULL};
static const GDBusArgInfo _pamac_daemon_dbus_arg_info_start_generate_mirrors_list_country = {-1, "country", "s", NULL};
static const GDBusArgInfo * const _pamac_daemon_dbus_arg_info_start_generate_mirrors_list_in[] = {&_pamac_daemon_dbus_arg_info_start_generate_mirrors_list_country, NULL};
static const GDBusArgInfo * const _pamac_daemon_dbus_arg_info_start_generate_mirrors_list_out[] = {NULL};
static const GDBusMethodInfo _pamac_daemon_dbus_method_info_start_generate_mirrors_list = {-1, "StartGenerateMirrorsList", (GDBusArgInfo **) (&_pamac_daemon_dbus_arg_info_start_generate_mirrors_list_in), (GDBusArgInfo **) (&_pamac_daemon_dbus_arg_info_start_generate_mirrors_list_out), NULL};
static const GDBusArgInfo _pamac_daemon_dbus_arg_info_start_clean_cache_filenames = {-1, "filenames", "as", NULL};
static const GDBusArgInfo * const _pamac_daemon_dbus_arg_info_start_clean_cache_in[] = {&_pamac_daemon_dbus_arg_info_start_clean_cache_filenames, NULL};
static const GDBusArgInfo * const _pamac_daemon_dbus_arg_info_start_clean_cache_out[] = {NULL};
static const GDBusMethodInfo _pamac_daemon_dbus_method_info_start_clean_cache = {-1, "StartCleanCache", (GDBusArgInfo **) (&_pamac_daemon_dbus_arg_info_start_clean_cache_in), (GDBusArgInfo **) (&_pamac_daemon_dbus_arg_info_start_clean_cache_out), NULL};
static const GDBusArgInfo _pamac_daemon_dbus_arg_info_start_clean_build_files_aur_build_dir = {-1, "aur_build_dir", "s", NULL};
static const GDBusArgInfo * const _pamac_daemon_dbus_arg_info_start_clean_build_files_in[] = {&_pamac_daemon_dbus_arg_info_start_clean_build_files_aur_build_dir, NULL};
static const GDBusArgInfo * const _pamac_daemon_dbus_arg_info_start_clean_build_files_out[] = {NULL};
static const GDBusMethodInfo _pamac_daemon_dbus_method_info_start_clean_build_files = {-1, "StartCleanBuildFiles", (GDBusArgInfo **) (&_pamac_daemon_dbus_arg_info_start_clean_build_files_in), (GDBusArgInfo **) (&_pamac_daemon_dbus_arg_info_start_clean_build_files_out), NULL};
static const GDBusArgInfo _pamac_daemon_dbus_arg_info_start_set_pkgreason_pkgname = {-1, "pkgname", "s", NULL};
static const GDBusArgInfo _pamac_daemon_dbus_arg_info_start_set_pkgreason_reason = {-1, "reason", "u", NULL};
static const GDBusArgInfo * const _pamac_daemon_dbus_arg_info_start_set_pkgreason_in[] = {&_pamac_daemon_dbus_arg_info_start_set_pkgreason_pkgname, &_pamac_daemon_dbus_arg_info_start_set_pkgreason_reason, NULL};
static const GDBusArgInfo * const _pamac_daemon_dbus_arg_info_start_set_pkgreason_out[] = {NULL};
static const GDBusMethodInfo _pamac_daemon_dbus_method_info_start_set_pkgreason = {-1, "StartSetPkgreason", (GDBusArgInfo **) (&_pamac_daemon_dbus_arg_info_start_set_pkgreason_in), (GDBusArgInfo **) (&_pamac_daemon_dbus_arg_info_start_set_pkgreason_out), NULL};
static const GDBusArgInfo * const _pamac_daemon_dbus_arg_info_start_download_updates_in[] = {NULL};
static const GDBusArgInfo * const _pamac_daemon_dbus_arg_info_start_download_updates_out[] = {NULL};
static const GDBusMethodInfo _pamac_daemon_dbus_method_info_start_download_updates = {-1, "StartDownloadUpdates", (GDBusArgInfo **) (&_pamac_daemon_dbus_arg_info_start_download_updates_in), (GDBusArgInfo **) (&_pamac_daemon_dbus_arg_info_start_download_updates_out), NULL};
static const GDBusArgInfo _pamac_daemon_dbus_arg_info_start_download_pkg_url = {-1, "url", "s", NULL};
static const GDBusArgInfo * const _pamac_daemon_dbus_arg_info_start_download_pkg_in[] = {&_pamac_daemon_dbus_arg_info_start_download_pkg_url, NULL};
static const GDBusArgInfo * const _pamac_daemon_dbus_arg_info_start_download_pkg_out[] = {NULL};
static const GDBusMethodInfo _pamac_daemon_dbus_method_info_start_download_pkg = {-1, "StartDownloadPkg", (GDBusArgInfo **) (&_pamac_daemon_dbus_arg_info_start_download_pkg_in), (GDBusArgInfo **) (&_pamac_daemon_dbus_arg_info_start_download_pkg_out), NULL};
static const GDBusArgInfo _pamac_daemon_dbus_arg_info_start_trans_refresh_force = {-1, "force", "b", NULL};
static const GDBusArgInfo * const _pamac_daemon_dbus_arg_info_start_trans_refresh_in[] = {&_pamac_daemon_dbus_arg_info_start_trans_refresh_force, NULL};
static const GDBusArgInfo * const _pamac_daemon_dbus_arg_info_start_trans_refresh_out[] = {NULL};
static const GDBusMethodInfo _pamac_daemon_dbus_method_info_start_trans_refresh = {-1, "StartTransRefresh", (GDBusArgInfo **) (&_pamac_daemon_dbus_arg_info_start_trans_refresh_in), (GDBusArgInfo **) (&_pamac_daemon_dbus_arg_info_start_trans_refresh_out), NULL};
static const GDBusArgInfo _pamac_daemon_dbus_arg_info_start_trans_run_sysupgrade = {-1, "sysupgrade", "b", NULL};
static const GDBusArgInfo _pamac_daemon_dbus_arg_info_start_trans_run_enable_downgrade = {-1, "enable_downgrade", "b", NULL};
static const GDBusArgInfo _pamac_daemon_dbus_arg_info_start_trans_run_simple_install = {-1, "simple_install", "b", NULL};
static const GDBusArgInfo _pamac_daemon_dbus_arg_info_start_trans_run_keep_built_pkgs = {-1, "keep_built_pkgs", "b", NULL};
static const GDBusArgInfo _pamac_daemon_dbus_arg_info_start_trans_run_trans_flags = {-1, "trans_flags", "i", NULL};
static const GDBusArgInfo _pamac_daemon_dbus_arg_info_start_trans_run_to_install = {-1, "to_install", "as", NULL};
static const GDBusArgInfo _pamac_daemon_dbus_arg_info_start_trans_run_to_remove = {-1, "to_remove", "as", NULL};
static const GDBusArgInfo _pamac_daemon_dbus_arg_info_start_trans_run_to_load = {-1, "to_load", "as", NULL};
static const GDBusArgInfo _pamac_daemon_dbus_arg_info_start_trans_run_to_install_as_dep = {-1, "to_install_as_dep", "as", NULL};
static const GDBusArgInfo _pamac_daemon_dbus_arg_info_start_trans_run_ignorepkgs = {-1, "ignorepkgs", "as", NULL};
static const GDBusArgInfo _pamac_daemon_dbus_arg_info_start_trans_run_overwrite_files = {-1, "overwrite_files", "as", NULL};
static const GDBusArgInfo * const _pamac_daemon_dbus_arg_info_start_trans_run_in[] = {&_pamac_daemon_dbus_arg_info_start_trans_run_sysupgrade, &_pamac_daemon_dbus_arg_info_start_trans_run_enable_downgrade, &_pamac_daemon_dbus_arg_info_start_trans_run_simple_install, &_pamac_daemon_dbus_arg_info_start_trans_run_keep_built_pkgs, &_pamac_daemon_dbus_arg_info_start_trans_run_trans_flags, &_pamac_daemon_dbus_arg_info_start_trans_run_to_install, &_pamac_daemon_dbus_arg_info_start_trans_run_to_remove, &_pamac_daemon_dbus_arg_info_start_trans_run_to_load, &_pamac_daemon_dbus_arg_info_start_trans_run_to_install_as_dep, &_pamac_daemon_dbus_arg_info_start_trans_run_ignorepkgs, &_pamac_daemon_dbus_arg_info_start_trans_run_overwrite_files, NULL};
static const GDBusArgInfo * const _pamac_daemon_dbus_arg_info_start_trans_run_out[] = {NULL};
static const GDBusMethodInfo _pamac_daemon_dbus_method_info_start_trans_run = {-1, "StartTransRun", (GDBusArgInfo **) (&_pamac_daemon_dbus_arg_info_start_trans_run_in), (GDBusArgInfo **) (&_pamac_daemon_dbus_arg_info_start_trans_run_out), NULL};
static const GDBusArgInfo * const _pamac_daemon_dbus_arg_info_trans_cancel_in[] = {NULL};
static const GDBusArgInfo * const _pamac_daemon_dbus_arg_info_trans_cancel_out[] = {NULL};
static const GDBusMethodInfo _pamac_daemon_dbus_method_info_trans_cancel = {-1, "TransCancel", (GDBusArgInfo **) (&_pamac_daemon_dbus_arg_info_trans_cancel_in), (GDBusArgInfo **) (&_pamac_daemon_dbus_arg_info_trans_cancel_out), NULL};
static const GDBusArgInfo * const _pamac_daemon_dbus_arg_info_quit_in[] = {NULL};
static const GDBusArgInfo * const _pamac_daemon_dbus_arg_info_quit_out[] = {NULL};
static const GDBusMethodInfo _pamac_daemon_dbus_method_info_quit = {-1, "Quit", (GDBusArgInfo **) (&_pamac_daemon_dbus_arg_info_quit_in), (GDBusArgInfo **) (&_pamac_daemon_dbus_arg_info_quit_out), NULL};
static const GDBusArgInfo _pamac_daemon_dbus_arg_info_start_snap_trans_run_to_install = {-1, "to_install", "as", NULL};
static const GDBusArgInfo _pamac_daemon_dbus_arg_info_start_snap_trans_run_to_remove = {-1, "to_remove", "as", NULL};
static const GDBusArgInfo * const _pamac_daemon_dbus_arg_info_start_snap_trans_run_in[] = {&_pamac_daemon_dbus_arg_info_start_snap_trans_run_to_install, &_pamac_daemon_dbus_arg_info_start_snap_trans_run_to_remove, NULL};
static const GDBusArgInfo * const _pamac_daemon_dbus_arg_info_start_snap_trans_run_out[] = {NULL};
static const GDBusMethodInfo _pamac_daemon_dbus_method_info_start_snap_trans_run = {-1, "StartSnapTransRun", (GDBusArgInfo **) (&_pamac_daemon_dbus_arg_info_start_snap_trans_run_in), (GDBusArgInfo **) (&_pamac_daemon_dbus_arg_info_start_snap_trans_run_out), NULL};
static const GDBusArgInfo _pamac_daemon_dbus_arg_info_start_snap_switch_channel_snap_name = {-1, "snap_name", "s", NULL};
static const GDBusArgInfo _pamac_daemon_dbus_arg_info_start_snap_switch_channel_channel = {-1, "channel", "s", NULL};
static const GDBusArgInfo * const _pamac_daemon_dbus_arg_info_start_snap_switch_channel_in[] = {&_pamac_daemon_dbus_arg_info_start_snap_switch_channel_snap_name, &_pamac_daemon_dbus_arg_info_start_snap_switch_channel_channel, NULL};
static const GDBusArgInfo * const _pamac_daemon_dbus_arg_info_start_snap_switch_channel_out[] = {NULL};
static const GDBusMethodInfo _pamac_daemon_dbus_method_info_start_snap_switch_channel = {-1, "StartSnapSwitchChannel", (GDBusArgInfo **) (&_pamac_daemon_dbus_arg_info_start_snap_switch_channel_in), (GDBusArgInfo **) (&_pamac_daemon_dbus_arg_info_start_snap_switch_channel_out), NULL};
static const GDBusArgInfo _pamac_daemon_dbus_arg_info_start_flatpak_trans_run_to_install = {-1, "to_install", "as", NULL};
static const GDBusArgInfo _pamac_daemon_dbus_arg_info_start_flatpak_trans_run_to_remove = {-1, "to_remove", "as", NULL};
static const GDBusArgInfo _pamac_daemon_dbus_arg_info_start_flatpak_trans_run_to_upgrade = {-1, "to_upgrade", "as", NULL};
static const GDBusArgInfo * const _pamac_daemon_dbus_arg_info_start_flatpak_trans_run_in[] = {&_pamac_daemon_dbus_arg_info_start_flatpak_trans_run_to_install, &_pamac_daemon_dbus_arg_info_start_flatpak_trans_run_to_remove, &_pamac_daemon_dbus_arg_info_start_flatpak_trans_run_to_upgrade, NULL};
static const GDBusArgInfo * const _pamac_daemon_dbus_arg_info_start_flatpak_trans_run_out[] = {NULL};
static const GDBusMethodInfo _pamac_daemon_dbus_method_info_start_flatpak_trans_run = {-1, "StartFlatpakTransRun", (GDBusArgInfo **) (&_pamac_daemon_dbus_arg_info_start_flatpak_trans_run_in), (GDBusArgInfo **) (&_pamac_daemon_dbus_arg_info_start_flatpak_trans_run_out), NULL};
static const GDBusMethodInfo * const _pamac_daemon_dbus_method_info[] = {&_pamac_daemon_dbus_method_info_get_sender, &_pamac_daemon_dbus_method_info_get_lockfile, &_pamac_daemon_dbus_method_info_set_environment_variables, &_pamac_daemon_dbus_method_info_start_get_authorization, &_pamac_daemon_dbus_method_info_remove_authorization, &_pamac_daemon_dbus_method_info_start_write_alpm_config, &_pamac_daemon_dbus_method_info_start_write_pamac_config, &_pamac_daemon_dbus_method_info_start_generate_mirrors_list, &_pamac_daemon_dbus_method_info_start_clean_cache, &_pamac_daemon_dbus_method_info_start_clean_build_files, &_pamac_daemon_dbus_method_info_start_set_pkgreason, &_pamac_daemon_dbus_method_info_start_download_updates, &_pamac_daemon_dbus_method_info_start_download_pkg, &_pamac_daemon_dbus_method_info_start_trans_refresh, &_pamac_daemon_dbus_method_info_start_trans_run, &_pamac_daemon_dbus_method_info_trans_cancel, &_pamac_daemon_dbus_method_info_quit, &_pamac_daemon_dbus_method_info_start_snap_trans_run, &_pamac_daemon_dbus_method_info_start_snap_switch_channel, &_pamac_daemon_dbus_method_info_start_flatpak_trans_run, NULL};
static const GDBusArgInfo _pamac_daemon_dbus_arg_info_emit_action_sender = {-1, "sender", "s", NULL};
static const GDBusArgInfo _pamac_daemon_dbus_arg_info_emit_action_action = {-1, "action", "s", NULL};
static const GDBusArgInfo * const _pamac_daemon_dbus_arg_info_emit_action[] = {&_pamac_daemon_dbus_arg_info_emit_action_sender, &_pamac_daemon_dbus_arg_info_emit_action_action, NULL};
static const GDBusSignalInfo _pamac_daemon_dbus_signal_info_emit_action = {-1, "EmitAction", (GDBusArgInfo **) (&_pamac_daemon_dbus_arg_info_emit_action), NULL};
static const GDBusArgInfo _pamac_daemon_dbus_arg_info_emit_action_progress_sender = {-1, "sender", "s", NULL};
static const GDBusArgInfo _pamac_daemon_dbus_arg_info_emit_action_progress_action = {-1, "action", "s", NULL};
static const GDBusArgInfo _pamac_daemon_dbus_arg_info_emit_action_progress_status = {-1, "status", "s", NULL};
static const GDBusArgInfo _pamac_daemon_dbus_arg_info_emit_action_progress_progress = {-1, "progress", "d", NULL};
static const GDBusArgInfo * const _pamac_daemon_dbus_arg_info_emit_action_progress[] = {&_pamac_daemon_dbus_arg_info_emit_action_progress_sender, &_pamac_daemon_dbus_arg_info_emit_action_progress_action, &_pamac_daemon_dbus_arg_info_emit_action_progress_status, &_pamac_daemon_dbus_arg_info_emit_action_progress_progress, NULL};
static const GDBusSignalInfo _pamac_daemon_dbus_signal_info_emit_action_progress = {-1, "EmitActionProgress", (GDBusArgInfo **) (&_pamac_daemon_dbus_arg_info_emit_action_progress), NULL};
static const GDBusArgInfo _pamac_daemon_dbus_arg_info_emit_download_progress_sender = {-1, "sender", "s", NULL};
static const GDBusArgInfo _pamac_daemon_dbus_arg_info_emit_download_progress_action = {-1, "action", "s", NULL};
static const GDBusArgInfo _pamac_daemon_dbus_arg_info_emit_download_progress_status = {-1, "status", "s", NULL};
static const GDBusArgInfo _pamac_daemon_dbus_arg_info_emit_download_progress_progress = {-1, "progress", "d", NULL};
static const GDBusArgInfo * const _pamac_daemon_dbus_arg_info_emit_download_progress[] = {&_pamac_daemon_dbus_arg_info_emit_download_progress_sender, &_pamac_daemon_dbus_arg_info_emit_download_progress_action, &_pamac_daemon_dbus_arg_info_emit_download_progress_status, &_pamac_daemon_dbus_arg_info_emit_download_progress_progress, NULL};
static const GDBusSignalInfo _pamac_daemon_dbus_signal_info_emit_download_progress = {-1, "EmitDownloadProgress", (GDBusArgInfo **) (&_pamac_daemon_dbus_arg_info_emit_download_progress), NULL};
static const GDBusArgInfo _pamac_daemon_dbus_arg_info_emit_hook_progress_sender = {-1, "sender", "s", NULL};
static const GDBusArgInfo _pamac_daemon_dbus_arg_info_emit_hook_progress_action = {-1, "action", "s", NULL};
static const GDBusArgInfo _pamac_daemon_dbus_arg_info_emit_hook_progress_details = {-1, "details", "s", NULL};
static const GDBusArgInfo _pamac_daemon_dbus_arg_info_emit_hook_progress_status = {-1, "status", "s", NULL};
static const GDBusArgInfo _pamac_daemon_dbus_arg_info_emit_hook_progress_progress = {-1, "progress", "d", NULL};
static const GDBusArgInfo * const _pamac_daemon_dbus_arg_info_emit_hook_progress[] = {&_pamac_daemon_dbus_arg_info_emit_hook_progress_sender, &_pamac_daemon_dbus_arg_info_emit_hook_progress_action, &_pamac_daemon_dbus_arg_info_emit_hook_progress_details, &_pamac_daemon_dbus_arg_info_emit_hook_progress_status, &_pamac_daemon_dbus_arg_info_emit_hook_progress_progress, NULL};
static const GDBusSignalInfo _pamac_daemon_dbus_signal_info_emit_hook_progress = {-1, "EmitHookProgress", (GDBusArgInfo **) (&_pamac_daemon_dbus_arg_info_emit_hook_progress), NULL};
static const GDBusArgInfo _pamac_daemon_dbus_arg_info_emit_script_output_sender = {-1, "sender", "s", NULL};
static const GDBusArgInfo _pamac_daemon_dbus_arg_info_emit_script_output_message = {-1, "message", "s", NULL};
static const GDBusArgInfo * const _pamac_daemon_dbus_arg_info_emit_script_output[] = {&_pamac_daemon_dbus_arg_info_emit_script_output_sender, &_pamac_daemon_dbus_arg_info_emit_script_output_message, NULL};
static const GDBusSignalInfo _pamac_daemon_dbus_signal_info_emit_script_output = {-1, "EmitScriptOutput", (GDBusArgInfo **) (&_pamac_daemon_dbus_arg_info_emit_script_output), NULL};
static const GDBusArgInfo _pamac_daemon_dbus_arg_info_emit_warning_sender = {-1, "sender", "s", NULL};
static const GDBusArgInfo _pamac_daemon_dbus_arg_info_emit_warning_message = {-1, "message", "s", NULL};
static const GDBusArgInfo * const _pamac_daemon_dbus_arg_info_emit_warning[] = {&_pamac_daemon_dbus_arg_info_emit_warning_sender, &_pamac_daemon_dbus_arg_info_emit_warning_message, NULL};
static const GDBusSignalInfo _pamac_daemon_dbus_signal_info_emit_warning = {-1, "EmitWarning", (GDBusArgInfo **) (&_pamac_daemon_dbus_arg_info_emit_warning), NULL};
static const GDBusArgInfo _pamac_daemon_dbus_arg_info_emit_error_sender = {-1, "sender", "s", NULL};
static const GDBusArgInfo _pamac_daemon_dbus_arg_info_emit_error_message = {-1, "message", "s", NULL};
static const GDBusArgInfo _pamac_daemon_dbus_arg_info_emit_error_details = {-1, "details", "as", NULL};
static const GDBusArgInfo * const _pamac_daemon_dbus_arg_info_emit_error[] = {&_pamac_daemon_dbus_arg_info_emit_error_sender, &_pamac_daemon_dbus_arg_info_emit_error_message, &_pamac_daemon_dbus_arg_info_emit_error_details, NULL};
static const GDBusSignalInfo _pamac_daemon_dbus_signal_info_emit_error = {-1, "EmitError", (GDBusArgInfo **) (&_pamac_daemon_dbus_arg_info_emit_error), NULL};
static const GDBusArgInfo _pamac_daemon_dbus_arg_info_important_details_outpout_sender = {-1, "sender", "s", NULL};
static const GDBusArgInfo _pamac_daemon_dbus_arg_info_important_details_outpout_must_show = {-1, "must_show", "b", NULL};
static const GDBusArgInfo * const _pamac_daemon_dbus_arg_info_important_details_outpout[] = {&_pamac_daemon_dbus_arg_info_important_details_outpout_sender, &_pamac_daemon_dbus_arg_info_important_details_outpout_must_show, NULL};
static const GDBusSignalInfo _pamac_daemon_dbus_signal_info_important_details_outpout = {-1, "ImportantDetailsOutpout", (GDBusArgInfo **) (&_pamac_daemon_dbus_arg_info_important_details_outpout), NULL};
static const GDBusArgInfo _pamac_daemon_dbus_arg_info_start_downloading_sender = {-1, "sender", "s", NULL};
static const GDBusArgInfo * const _pamac_daemon_dbus_arg_info_start_downloading[] = {&_pamac_daemon_dbus_arg_info_start_downloading_sender, NULL};
static const GDBusSignalInfo _pamac_daemon_dbus_signal_info_start_downloading = {-1, "StartDownloading", (GDBusArgInfo **) (&_pamac_daemon_dbus_arg_info_start_downloading), NULL};
static const GDBusArgInfo _pamac_daemon_dbus_arg_info_stop_downloading_sender = {-1, "sender", "s", NULL};
static const GDBusArgInfo * const _pamac_daemon_dbus_arg_info_stop_downloading[] = {&_pamac_daemon_dbus_arg_info_stop_downloading_sender, NULL};
static const GDBusSignalInfo _pamac_daemon_dbus_signal_info_stop_downloading = {-1, "StopDownloading", (GDBusArgInfo **) (&_pamac_daemon_dbus_arg_info_stop_downloading), NULL};
static const GDBusArgInfo _pamac_daemon_dbus_arg_info_set_pkgreason_finished_sender = {-1, "sender", "s", NULL};
static const GDBusArgInfo _pamac_daemon_dbus_arg_info_set_pkgreason_finished_success = {-1, "success", "b", NULL};
static const GDBusArgInfo * const _pamac_daemon_dbus_arg_info_set_pkgreason_finished[] = {&_pamac_daemon_dbus_arg_info_set_pkgreason_finished_sender, &_pamac_daemon_dbus_arg_info_set_pkgreason_finished_success, NULL};
static const GDBusSignalInfo _pamac_daemon_dbus_signal_info_set_pkgreason_finished = {-1, "SetPkgreasonFinished", (GDBusArgInfo **) (&_pamac_daemon_dbus_arg_info_set_pkgreason_finished), NULL};
static const GDBusArgInfo _pamac_daemon_dbus_arg_info_start_waiting_sender = {-1, "sender", "s", NULL};
static const GDBusArgInfo * const _pamac_daemon_dbus_arg_info_start_waiting[] = {&_pamac_daemon_dbus_arg_info_start_waiting_sender, NULL};
static const GDBusSignalInfo _pamac_daemon_dbus_signal_info_start_waiting = {-1, "StartWaiting", (GDBusArgInfo **) (&_pamac_daemon_dbus_arg_info_start_waiting), NULL};
static const GDBusArgInfo _pamac_daemon_dbus_arg_info_stop_waiting_sender = {-1, "sender", "s", NULL};
static const GDBusArgInfo * const _pamac_daemon_dbus_arg_info_stop_waiting[] = {&_pamac_daemon_dbus_arg_info_stop_waiting_sender, NULL};
static const GDBusSignalInfo _pamac_daemon_dbus_signal_info_stop_waiting = {-1, "StopWaiting", (GDBusArgInfo **) (&_pamac_daemon_dbus_arg_info_stop_waiting), NULL};
static const GDBusArgInfo _pamac_daemon_dbus_arg_info_download_pkg_finished_sender = {-1, "sender", "s", NULL};
static const GDBusArgInfo _pamac_daemon_dbus_arg_info_download_pkg_finished_path = {-1, "path", "s", NULL};
static const GDBusArgInfo * const _pamac_daemon_dbus_arg_info_download_pkg_finished[] = {&_pamac_daemon_dbus_arg_info_download_pkg_finished_sender, &_pamac_daemon_dbus_arg_info_download_pkg_finished_path, NULL};
static const GDBusSignalInfo _pamac_daemon_dbus_signal_info_download_pkg_finished = {-1, "DownloadPkgFinished", (GDBusArgInfo **) (&_pamac_daemon_dbus_arg_info_download_pkg_finished), NULL};
static const GDBusArgInfo _pamac_daemon_dbus_arg_info_trans_refresh_finished_sender = {-1, "sender", "s", NULL};
static const GDBusArgInfo _pamac_daemon_dbus_arg_info_trans_refresh_finished_success = {-1, "success", "b", NULL};
static const GDBusArgInfo * const _pamac_daemon_dbus_arg_info_trans_refresh_finished[] = {&_pamac_daemon_dbus_arg_info_trans_refresh_finished_sender, &_pamac_daemon_dbus_arg_info_trans_refresh_finished_success, NULL};
static const GDBusSignalInfo _pamac_daemon_dbus_signal_info_trans_refresh_finished = {-1, "TransRefreshFinished", (GDBusArgInfo **) (&_pamac_daemon_dbus_arg_info_trans_refresh_finished), NULL};
static const GDBusArgInfo _pamac_daemon_dbus_arg_info_trans_run_finished_sender = {-1, "sender", "s", NULL};
static const GDBusArgInfo _pamac_daemon_dbus_arg_info_trans_run_finished_success = {-1, "success", "b", NULL};
static const GDBusArgInfo * const _pamac_daemon_dbus_arg_info_trans_run_finished[] = {&_pamac_daemon_dbus_arg_info_trans_run_finished_sender, &_pamac_daemon_dbus_arg_info_trans_run_finished_success, NULL};
static const GDBusSignalInfo _pamac_daemon_dbus_signal_info_trans_run_finished = {-1, "TransRunFinished", (GDBusArgInfo **) (&_pamac_daemon_dbus_arg_info_trans_run_finished), NULL};
static const GDBusArgInfo _pamac_daemon_dbus_arg_info_download_updates_finished_sender = {-1, "sender", "s", NULL};
static const GDBusArgInfo _pamac_daemon_dbus_arg_info_download_updates_finished_success = {-1, "success", "b", NULL};
static const GDBusArgInfo * const _pamac_daemon_dbus_arg_info_download_updates_finished[] = {&_pamac_daemon_dbus_arg_info_download_updates_finished_sender, &_pamac_daemon_dbus_arg_info_download_updates_finished_success, NULL};
static const GDBusSignalInfo _pamac_daemon_dbus_signal_info_download_updates_finished = {-1, "DownloadUpdatesFinished", (GDBusArgInfo **) (&_pamac_daemon_dbus_arg_info_download_updates_finished), NULL};
static const GDBusArgInfo _pamac_daemon_dbus_arg_info_get_authorization_finished_sender = {-1, "sender", "s", NULL};
static const GDBusArgInfo _pamac_daemon_dbus_arg_info_get_authorization_finished_authorized = {-1, "authorized", "b", NULL};
static const GDBusArgInfo * const _pamac_daemon_dbus_arg_info_get_authorization_finished[] = {&_pamac_daemon_dbus_arg_info_get_authorization_finished_sender, &_pamac_daemon_dbus_arg_info_get_authorization_finished_authorized, NULL};
static const GDBusSignalInfo _pamac_daemon_dbus_signal_info_get_authorization_finished = {-1, "GetAuthorizationFinished", (GDBusArgInfo **) (&_pamac_daemon_dbus_arg_info_get_authorization_finished), NULL};
static const GDBusArgInfo _pamac_daemon_dbus_arg_info_write_alpm_config_finished_sender = {-1, "sender", "s", NULL};
static const GDBusArgInfo * const _pamac_daemon_dbus_arg_info_write_alpm_config_finished[] = {&_pamac_daemon_dbus_arg_info_write_alpm_config_finished_sender, NULL};
static const GDBusSignalInfo _pamac_daemon_dbus_signal_info_write_alpm_config_finished = {-1, "WriteAlpmConfigFinished", (GDBusArgInfo **) (&_pamac_daemon_dbus_arg_info_write_alpm_config_finished), NULL};
static const GDBusArgInfo _pamac_daemon_dbus_arg_info_write_pamac_config_finished_sender = {-1, "sender", "s", NULL};
static const GDBusArgInfo * const _pamac_daemon_dbus_arg_info_write_pamac_config_finished[] = {&_pamac_daemon_dbus_arg_info_write_pamac_config_finished_sender, NULL};
static const GDBusSignalInfo _pamac_daemon_dbus_signal_info_write_pamac_config_finished = {-1, "WritePamacConfigFinished", (GDBusArgInfo **) (&_pamac_daemon_dbus_arg_info_write_pamac_config_finished), NULL};
static const GDBusArgInfo _pamac_daemon_dbus_arg_info_generate_mirrors_list_data_sender = {-1, "sender", "s", NULL};
static const GDBusArgInfo _pamac_daemon_dbus_arg_info_generate_mirrors_list_data_line = {-1, "line", "s", NULL};
static const GDBusArgInfo * const _pamac_daemon_dbus_arg_info_generate_mirrors_list_data[] = {&_pamac_daemon_dbus_arg_info_generate_mirrors_list_data_sender, &_pamac_daemon_dbus_arg_info_generate_mirrors_list_data_line, NULL};
static const GDBusSignalInfo _pamac_daemon_dbus_signal_info_generate_mirrors_list_data = {-1, "GenerateMirrorsListData", (GDBusArgInfo **) (&_pamac_daemon_dbus_arg_info_generate_mirrors_list_data), NULL};
static const GDBusArgInfo _pamac_daemon_dbus_arg_info_generate_mirrors_list_finished_sender = {-1, "sender", "s", NULL};
static const GDBusArgInfo * const _pamac_daemon_dbus_arg_info_generate_mirrors_list_finished[] = {&_pamac_daemon_dbus_arg_info_generate_mirrors_list_finished_sender, NULL};
static const GDBusSignalInfo _pamac_daemon_dbus_signal_info_generate_mirrors_list_finished = {-1, "GenerateMirrorsListFinished", (GDBusArgInfo **) (&_pamac_daemon_dbus_arg_info_generate_mirrors_list_finished), NULL};
static const GDBusArgInfo _pamac_daemon_dbus_arg_info_clean_cache_finished_sender = {-1, "sender", "s", NULL};
static const GDBusArgInfo _pamac_daemon_dbus_arg_info_clean_cache_finished_success = {-1, "success", "b", NULL};
static const GDBusArgInfo * const _pamac_daemon_dbus_arg_info_clean_cache_finished[] = {&_pamac_daemon_dbus_arg_info_clean_cache_finished_sender, &_pamac_daemon_dbus_arg_info_clean_cache_finished_success, NULL};
static const GDBusSignalInfo _pamac_daemon_dbus_signal_info_clean_cache_finished = {-1, "CleanCacheFinished", (GDBusArgInfo **) (&_pamac_daemon_dbus_arg_info_clean_cache_finished), NULL};
static const GDBusArgInfo _pamac_daemon_dbus_arg_info_clean_build_files_finished_sender = {-1, "sender", "s", NULL};
static const GDBusArgInfo _pamac_daemon_dbus_arg_info_clean_build_files_finished_success = {-1, "success", "b", NULL};
static const GDBusArgInfo * const _pamac_daemon_dbus_arg_info_clean_build_files_finished[] = {&_pamac_daemon_dbus_arg_info_clean_build_files_finished_sender, &_pamac_daemon_dbus_arg_info_clean_build_files_finished_success, NULL};
static const GDBusSignalInfo _pamac_daemon_dbus_signal_info_clean_build_files_finished = {-1, "CleanBuildFilesFinished", (GDBusArgInfo **) (&_pamac_daemon_dbus_arg_info_clean_build_files_finished), NULL};
static const GDBusArgInfo _pamac_daemon_dbus_arg_info_snap_trans_run_finished_sender = {-1, "sender", "s", NULL};
static const GDBusArgInfo _pamac_daemon_dbus_arg_info_snap_trans_run_finished_success = {-1, "success", "b", NULL};
static const GDBusArgInfo * const _pamac_daemon_dbus_arg_info_snap_trans_run_finished[] = {&_pamac_daemon_dbus_arg_info_snap_trans_run_finished_sender, &_pamac_daemon_dbus_arg_info_snap_trans_run_finished_success, NULL};
static const GDBusSignalInfo _pamac_daemon_dbus_signal_info_snap_trans_run_finished = {-1, "SnapTransRunFinished", (GDBusArgInfo **) (&_pamac_daemon_dbus_arg_info_snap_trans_run_finished), NULL};
static const GDBusArgInfo _pamac_daemon_dbus_arg_info_snap_switch_channel_finished_sender = {-1, "sender", "s", NULL};
static const GDBusArgInfo _pamac_daemon_dbus_arg_info_snap_switch_channel_finished_success = {-1, "success", "b", NULL};
static const GDBusArgInfo * const _pamac_daemon_dbus_arg_info_snap_switch_channel_finished[] = {&_pamac_daemon_dbus_arg_info_snap_switch_channel_finished_sender, &_pamac_daemon_dbus_arg_info_snap_switch_channel_finished_success, NULL};
static const GDBusSignalInfo _pamac_daemon_dbus_signal_info_snap_switch_channel_finished = {-1, "SnapSwitchChannelFinished", (GDBusArgInfo **) (&_pamac_daemon_dbus_arg_info_snap_switch_channel_finished), NULL};
static const GDBusArgInfo _pamac_daemon_dbus_arg_info_flatpak_trans_run_finished_sender = {-1, "sender", "s", NULL};
static const GDBusArgInfo _pamac_daemon_dbus_arg_info_flatpak_trans_run_finished_success = {-1, "success", "b", NULL};
static const GDBusArgInfo * const _pamac_daemon_dbus_arg_info_flatpak_trans_run_finished[] = {&_pamac_daemon_dbus_arg_info_flatpak_trans_run_finished_sender, &_pamac_daemon_dbus_arg_info_flatpak_trans_run_finished_success, NULL};
static const GDBusSignalInfo _pamac_daemon_dbus_signal_info_flatpak_trans_run_finished = {-1, "FlatpakTransRunFinished", (GDBusArgInfo **) (&_pamac_daemon_dbus_arg_info_flatpak_trans_run_finished), NULL};
static const GDBusSignalInfo * const _pamac_daemon_dbus_signal_info[] = {&_pamac_daemon_dbus_signal_info_emit_action, &_pamac_daemon_dbus_signal_info_emit_action_progress, &_pamac_daemon_dbus_signal_info_emit_download_progress, &_pamac_daemon_dbus_signal_info_emit_hook_progress, &_pamac_daemon_dbus_signal_info_emit_script_output, &_pamac_daemon_dbus_signal_info_emit_warning, &_pamac_daemon_dbus_signal_info_emit_error, &_pamac_daemon_dbus_signal_info_important_details_outpout, &_pamac_daemon_dbus_signal_info_start_downloading, &_pamac_daemon_dbus_signal_info_stop_downloading, &_pamac_daemon_dbus_signal_info_set_pkgreason_finished, &_pamac_daemon_dbus_signal_info_start_waiting, &_pamac_daemon_dbus_signal_info_stop_waiting, &_pamac_daemon_dbus_signal_info_download_pkg_finished, &_pamac_daemon_dbus_signal_info_trans_refresh_finished, &_pamac_daemon_dbus_signal_info_trans_run_finished, &_pamac_daemon_dbus_signal_info_download_updates_finished, &_pamac_daemon_dbus_signal_info_get_authorization_finished, &_pamac_daemon_dbus_signal_info_write_alpm_config_finished, &_pamac_daemon_dbus_signal_info_write_pamac_config_finished, &_pamac_daemon_dbus_signal_info_generate_mirrors_list_data, &_pamac_daemon_dbus_signal_info_generate_mirrors_list_finished, &_pamac_daemon_dbus_signal_info_clean_cache_finished, &_pamac_daemon_dbus_signal_info_clean_build_files_finished, &_pamac_daemon_dbus_signal_info_snap_trans_run_finished, &_pamac_daemon_dbus_signal_info_snap_switch_channel_finished, &_pamac_daemon_dbus_signal_info_flatpak_trans_run_finished, NULL};
static const GDBusPropertyInfo * const _pamac_daemon_dbus_property_info[] = {NULL};
static const GDBusInterfaceInfo _pamac_daemon_dbus_interface_info = {-1, "org.manjaro.pamac.daemon", (GDBusMethodInfo **) (&_pamac_daemon_dbus_method_info), (GDBusSignalInfo **) (&_pamac_daemon_dbus_signal_info), (GDBusPropertyInfo **) (&_pamac_daemon_dbus_property_info), NULL};
static const GDBusInterfaceVTable _pamac_daemon_dbus_interface_vtable = {pamac_daemon_dbus_interface_method_call, pamac_daemon_dbus_interface_get_property, pamac_daemon_dbus_interface_set_property};

gchar*
pamac_daemon_get_sender (PamacDaemon* self,
                         GError** error)
{
	PamacDaemonIface* _iface_;
	g_return_val_if_fail (self != NULL, NULL);
	_iface_ = PAMAC_DAEMON_GET_INTERFACE (self);
	if (_iface_->get_sender) {
		return _iface_->get_sender (self, error);
	}
	return NULL;
}

gchar*
pamac_daemon_get_lockfile (PamacDaemon* self,
                           GError** error)
{
	PamacDaemonIface* _iface_;
	g_return_val_if_fail (self != NULL, NULL);
	_iface_ = PAMAC_DAEMON_GET_INTERFACE (self);
	if (_iface_->get_lockfile) {
		return _iface_->get_lockfile (self, error);
	}
	return NULL;
}

void
pamac_daemon_set_environment_variables (PamacDaemon* self,
                                        GHashTable* variables,
                                        GError** error)
{
	PamacDaemonIface* _iface_;
	g_return_if_fail (self != NULL);
	_iface_ = PAMAC_DAEMON_GET_INTERFACE (self);
	if (_iface_->set_environment_variables) {
		_iface_->set_environment_variables (self, variables, error);
	}
}

void
pamac_daemon_start_get_authorization (PamacDaemon* self,
                                      GError** error)
{
	PamacDaemonIface* _iface_;
	g_return_if_fail (self != NULL);
	_iface_ = PAMAC_DAEMON_GET_INTERFACE (self);
	if (_iface_->start_get_authorization) {
		_iface_->start_get_authorization (self, error);
	}
}

void
pamac_daemon_remove_authorization (PamacDaemon* self,
                                   GError** error)
{
	PamacDaemonIface* _iface_;
	g_return_if_fail (self != NULL);
	_iface_ = PAMAC_DAEMON_GET_INTERFACE (self);
	if (_iface_->remove_authorization) {
		_iface_->remove_authorization (self, error);
	}
}

void
pamac_daemon_start_write_alpm_config (PamacDaemon* self,
                                      GHashTable* new_alpm_conf,
                                      GError** error)
{
	PamacDaemonIface* _iface_;
	g_return_if_fail (self != NULL);
	_iface_ = PAMAC_DAEMON_GET_INTERFACE (self);
	if (_iface_->start_write_alpm_config) {
		_iface_->start_write_alpm_config (self, new_alpm_conf, error);
	}
}

void
pamac_daemon_start_write_pamac_config (PamacDaemon* self,
                                       GHashTable* new_pamac_conf,
                                       GError** error)
{
	PamacDaemonIface* _iface_;
	g_return_if_fail (self != NULL);
	_iface_ = PAMAC_DAEMON_GET_INTERFACE (self);
	if (_iface_->start_write_pamac_config) {
		_iface_->start_write_pamac_config (self, new_pamac_conf, error);
	}
}

void
pamac_daemon_start_generate_mirrors_list (PamacDaemon* self,
                                          const gchar* country,
                                          GError** error)
{
	PamacDaemonIface* _iface_;
	g_return_if_fail (self != NULL);
	_iface_ = PAMAC_DAEMON_GET_INTERFACE (self);
	if (_iface_->start_generate_mirrors_list) {
		_iface_->start_generate_mirrors_list (self, country, error);
	}
}

void
pamac_daemon_start_clean_cache (PamacDaemon* self,
                                gchar** filenames,
                                gint filenames_length1,
                                GError** error)
{
	PamacDaemonIface* _iface_;
	g_return_if_fail (self != NULL);
	_iface_ = PAMAC_DAEMON_GET_INTERFACE (self);
	if (_iface_->start_clean_cache) {
		_iface_->start_clean_cache (self, filenames, filenames_length1, error);
	}
}

void
pamac_daemon_start_clean_build_files (PamacDaemon* self,
                                      const gchar* aur_build_dir,
                                      GError** error)
{
	PamacDaemonIface* _iface_;
	g_return_if_fail (self != NULL);
	_iface_ = PAMAC_DAEMON_GET_INTERFACE (self);
	if (_iface_->start_clean_build_files) {
		_iface_->start_clean_build_files (self, aur_build_dir, error);
	}
}

void
pamac_daemon_start_set_pkgreason (PamacDaemon* self,
                                  const gchar* pkgname,
                                  guint reason,
                                  GError** error)
{
	PamacDaemonIface* _iface_;
	g_return_if_fail (self != NULL);
	_iface_ = PAMAC_DAEMON_GET_INTERFACE (self);
	if (_iface_->start_set_pkgreason) {
		_iface_->start_set_pkgreason (self, pkgname, reason, error);
	}
}

void
pamac_daemon_start_download_updates (PamacDaemon* self,
                                     GError** error)
{
	PamacDaemonIface* _iface_;
	g_return_if_fail (self != NULL);
	_iface_ = PAMAC_DAEMON_GET_INTERFACE (self);
	if (_iface_->start_download_updates) {
		_iface_->start_download_updates (self, error);
	}
}

void
pamac_daemon_start_download_pkg (PamacDaemon* self,
                                 const gchar* url,
                                 GError** error)
{
	PamacDaemonIface* _iface_;
	g_return_if_fail (self != NULL);
	_iface_ = PAMAC_DAEMON_GET_INTERFACE (self);
	if (_iface_->start_download_pkg) {
		_iface_->start_download_pkg (self, url, error);
	}
}

void
pamac_daemon_start_trans_refresh (PamacDaemon* self,
                                  gboolean force,
                                  GError** error)
{
	PamacDaemonIface* _iface_;
	g_return_if_fail (self != NULL);
	_iface_ = PAMAC_DAEMON_GET_INTERFACE (self);
	if (_iface_->start_trans_refresh) {
		_iface_->start_trans_refresh (self, force, error);
	}
}

void
pamac_daemon_start_trans_run (PamacDaemon* self,
                              gboolean sysupgrade,
                              gboolean enable_downgrade,
                              gboolean simple_install,
                              gboolean keep_built_pkgs,
                              gint trans_flags,
                              gchar** to_install,
                              gint to_install_length1,
                              gchar** to_remove,
                              gint to_remove_length1,
                              gchar** to_load,
                              gint to_load_length1,
                              gchar** to_install_as_dep,
                              gint to_install_as_dep_length1,
                              gchar** ignorepkgs,
                              gint ignorepkgs_length1,
                              gchar** overwrite_files,
                              gint overwrite_files_length1,
                              GError** error)
{
	PamacDaemonIface* _iface_;
	g_return_if_fail (self != NULL);
	_iface_ = PAMAC_DAEMON_GET_INTERFACE (self);
	if (_iface_->start_trans_run) {
		_iface_->start_trans_run (self, sysupgrade, enable_downgrade, simple_install, keep_built_pkgs, trans_flags, to_install, to_install_length1, to_remove, to_remove_length1, to_load, to_load_length1, to_install_as_dep, to_install_as_dep_length1, ignorepkgs, ignorepkgs_length1, overwrite_files, overwrite_files_length1, error);
	}
}

void
pamac_daemon_trans_cancel (PamacDaemon* self,
                           GError** error)
{
	PamacDaemonIface* _iface_;
	g_return_if_fail (self != NULL);
	_iface_ = PAMAC_DAEMON_GET_INTERFACE (self);
	if (_iface_->trans_cancel) {
		_iface_->trans_cancel (self, error);
	}
}

void
pamac_daemon_quit (PamacDaemon* self,
                   GError** error)
{
	PamacDaemonIface* _iface_;
	g_return_if_fail (self != NULL);
	_iface_ = PAMAC_DAEMON_GET_INTERFACE (self);
	if (_iface_->quit) {
		_iface_->quit (self, error);
	}
}

void
pamac_daemon_start_snap_trans_run (PamacDaemon* self,
                                   gchar** to_install,
                                   gint to_install_length1,
                                   gchar** to_remove,
                                   gint to_remove_length1,
                                   GError** error)
{
	PamacDaemonIface* _iface_;
	g_return_if_fail (self != NULL);
	_iface_ = PAMAC_DAEMON_GET_INTERFACE (self);
	if (_iface_->start_snap_trans_run) {
		_iface_->start_snap_trans_run (self, to_install, to_install_length1, to_remove, to_remove_length1, error);
	}
}

void
pamac_daemon_start_snap_switch_channel (PamacDaemon* self,
                                        const gchar* snap_name,
                                        const gchar* channel,
                                        GError** error)
{
	PamacDaemonIface* _iface_;
	g_return_if_fail (self != NULL);
	_iface_ = PAMAC_DAEMON_GET_INTERFACE (self);
	if (_iface_->start_snap_switch_channel) {
		_iface_->start_snap_switch_channel (self, snap_name, channel, error);
	}
}

void
pamac_daemon_start_flatpak_trans_run (PamacDaemon* self,
                                      gchar** to_install,
                                      gint to_install_length1,
                                      gchar** to_remove,
                                      gint to_remove_length1,
                                      gchar** to_upgrade,
                                      gint to_upgrade_length1,
                                      GError** error)
{
	PamacDaemonIface* _iface_;
	g_return_if_fail (self != NULL);
	_iface_ = PAMAC_DAEMON_GET_INTERFACE (self);
	if (_iface_->start_flatpak_trans_run) {
		_iface_->start_flatpak_trans_run (self, to_install, to_install_length1, to_remove, to_remove_length1, to_upgrade, to_upgrade_length1, error);
	}
}

static void
g_cclosure_user_marshal_VOID__STRING_STRING (GClosure * closure,
                                             GValue * return_value,
                                             guint n_param_values,
                                             const GValue * param_values,
                                             gpointer invocation_hint,
                                             gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__STRING_STRING) (gpointer data1, const char* arg_1, const char* arg_2, gpointer data2);
	register GMarshalFunc_VOID__STRING_STRING callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__STRING_STRING) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_string (param_values + 1), g_value_get_string (param_values + 2), data2);
}

static void
g_cclosure_user_marshal_VOID__STRING_STRING_STRING_DOUBLE (GClosure * closure,
                                                           GValue * return_value,
                                                           guint n_param_values,
                                                           const GValue * param_values,
                                                           gpointer invocation_hint,
                                                           gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__STRING_STRING_STRING_DOUBLE) (gpointer data1, const char* arg_1, const char* arg_2, const char* arg_3, gdouble arg_4, gpointer data2);
	register GMarshalFunc_VOID__STRING_STRING_STRING_DOUBLE callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 5);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__STRING_STRING_STRING_DOUBLE) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_string (param_values + 1), g_value_get_string (param_values + 2), g_value_get_string (param_values + 3), g_value_get_double (param_values + 4), data2);
}

static void
g_cclosure_user_marshal_VOID__STRING_STRING_STRING_STRING_DOUBLE (GClosure * closure,
                                                                  GValue * return_value,
                                                                  guint n_param_values,
                                                                  const GValue * param_values,
                                                                  gpointer invocation_hint,
                                                                  gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__STRING_STRING_STRING_STRING_DOUBLE) (gpointer data1, const char* arg_1, const char* arg_2, const char* arg_3, const char* arg_4, gdouble arg_5, gpointer data2);
	register GMarshalFunc_VOID__STRING_STRING_STRING_STRING_DOUBLE callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 6);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__STRING_STRING_STRING_STRING_DOUBLE) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_string (param_values + 1), g_value_get_string (param_values + 2), g_value_get_string (param_values + 3), g_value_get_string (param_values + 4), g_value_get_double (param_values + 5), data2);
}

static void
g_cclosure_user_marshal_VOID__STRING_STRING_BOXED_INT (GClosure * closure,
                                                       GValue * return_value,
                                                       guint n_param_values,
                                                       const GValue * param_values,
                                                       gpointer invocation_hint,
                                                       gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__STRING_STRING_BOXED_INT) (gpointer data1, const char* arg_1, const char* arg_2, gpointer arg_3, gint arg_4, gpointer data2);
	register GMarshalFunc_VOID__STRING_STRING_BOXED_INT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 5);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__STRING_STRING_BOXED_INT) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_string (param_values + 1), g_value_get_string (param_values + 2), g_value_get_boxed (param_values + 3), g_value_get_int (param_values + 4), data2);
}

static void
g_cclosure_user_marshal_VOID__STRING_BOOLEAN (GClosure * closure,
                                              GValue * return_value,
                                              guint n_param_values,
                                              const GValue * param_values,
                                              gpointer invocation_hint,
                                              gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__STRING_BOOLEAN) (gpointer data1, const char* arg_1, gboolean arg_2, gpointer data2);
	register GMarshalFunc_VOID__STRING_BOOLEAN callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__STRING_BOOLEAN) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_string (param_values + 1), g_value_get_boolean (param_values + 2), data2);
}

static void
pamac_daemon_default_init (PamacDaemonIface * iface,
                           gpointer iface_data)
{
	pamac_daemon_signals[PAMAC_DAEMON_EMIT_ACTION_SIGNAL] = g_signal_new ("emit-action", PAMAC_TYPE_DAEMON, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_STRING, G_TYPE_NONE, 2, G_TYPE_STRING, G_TYPE_STRING);
	pamac_daemon_signals[PAMAC_DAEMON_EMIT_ACTION_PROGRESS_SIGNAL] = g_signal_new ("emit-action-progress", PAMAC_TYPE_DAEMON, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_STRING_STRING_DOUBLE, G_TYPE_NONE, 4, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_DOUBLE);
	pamac_daemon_signals[PAMAC_DAEMON_EMIT_DOWNLOAD_PROGRESS_SIGNAL] = g_signal_new ("emit-download-progress", PAMAC_TYPE_DAEMON, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_STRING_STRING_DOUBLE, G_TYPE_NONE, 4, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_DOUBLE);
	pamac_daemon_signals[PAMAC_DAEMON_EMIT_HOOK_PROGRESS_SIGNAL] = g_signal_new ("emit-hook-progress", PAMAC_TYPE_DAEMON, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_STRING_STRING_STRING_DOUBLE, G_TYPE_NONE, 5, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_DOUBLE);
	pamac_daemon_signals[PAMAC_DAEMON_EMIT_SCRIPT_OUTPUT_SIGNAL] = g_signal_new ("emit-script-output", PAMAC_TYPE_DAEMON, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_STRING, G_TYPE_NONE, 2, G_TYPE_STRING, G_TYPE_STRING);
	pamac_daemon_signals[PAMAC_DAEMON_EMIT_WARNING_SIGNAL] = g_signal_new ("emit-warning", PAMAC_TYPE_DAEMON, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_STRING, G_TYPE_NONE, 2, G_TYPE_STRING, G_TYPE_STRING);
	pamac_daemon_signals[PAMAC_DAEMON_EMIT_ERROR_SIGNAL] = g_signal_new ("emit-error", PAMAC_TYPE_DAEMON, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_STRING_BOXED_INT, G_TYPE_NONE, 4, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRV, G_TYPE_INT);
	pamac_daemon_signals[PAMAC_DAEMON_IMPORTANT_DETAILS_OUTPOUT_SIGNAL] = g_signal_new ("important-details-outpout", PAMAC_TYPE_DAEMON, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_BOOLEAN, G_TYPE_NONE, 2, G_TYPE_STRING, G_TYPE_BOOLEAN);
	pamac_daemon_signals[PAMAC_DAEMON_START_DOWNLOADING_SIGNAL] = g_signal_new ("start-downloading", PAMAC_TYPE_DAEMON, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
	pamac_daemon_signals[PAMAC_DAEMON_STOP_DOWNLOADING_SIGNAL] = g_signal_new ("stop-downloading", PAMAC_TYPE_DAEMON, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
	pamac_daemon_signals[PAMAC_DAEMON_SET_PKGREASON_FINISHED_SIGNAL] = g_signal_new ("set-pkgreason-finished", PAMAC_TYPE_DAEMON, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_BOOLEAN, G_TYPE_NONE, 2, G_TYPE_STRING, G_TYPE_BOOLEAN);
	pamac_daemon_signals[PAMAC_DAEMON_START_WAITING_SIGNAL] = g_signal_new ("start-waiting", PAMAC_TYPE_DAEMON, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
	pamac_daemon_signals[PAMAC_DAEMON_STOP_WAITING_SIGNAL] = g_signal_new ("stop-waiting", PAMAC_TYPE_DAEMON, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
	pamac_daemon_signals[PAMAC_DAEMON_DOWNLOAD_PKG_FINISHED_SIGNAL] = g_signal_new ("download-pkg-finished", PAMAC_TYPE_DAEMON, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_STRING, G_TYPE_NONE, 2, G_TYPE_STRING, G_TYPE_STRING);
	pamac_daemon_signals[PAMAC_DAEMON_TRANS_REFRESH_FINISHED_SIGNAL] = g_signal_new ("trans-refresh-finished", PAMAC_TYPE_DAEMON, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_BOOLEAN, G_TYPE_NONE, 2, G_TYPE_STRING, G_TYPE_BOOLEAN);
	pamac_daemon_signals[PAMAC_DAEMON_TRANS_RUN_FINISHED_SIGNAL] = g_signal_new ("trans-run-finished", PAMAC_TYPE_DAEMON, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_BOOLEAN, G_TYPE_NONE, 2, G_TYPE_STRING, G_TYPE_BOOLEAN);
	pamac_daemon_signals[PAMAC_DAEMON_DOWNLOAD_UPDATES_FINISHED_SIGNAL] = g_signal_new ("download-updates-finished", PAMAC_TYPE_DAEMON, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_BOOLEAN, G_TYPE_NONE, 2, G_TYPE_STRING, G_TYPE_BOOLEAN);
	pamac_daemon_signals[PAMAC_DAEMON_GET_AUTHORIZATION_FINISHED_SIGNAL] = g_signal_new ("get-authorization-finished", PAMAC_TYPE_DAEMON, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_BOOLEAN, G_TYPE_NONE, 2, G_TYPE_STRING, G_TYPE_BOOLEAN);
	pamac_daemon_signals[PAMAC_DAEMON_WRITE_ALPM_CONFIG_FINISHED_SIGNAL] = g_signal_new ("write-alpm-config-finished", PAMAC_TYPE_DAEMON, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
	pamac_daemon_signals[PAMAC_DAEMON_WRITE_PAMAC_CONFIG_FINISHED_SIGNAL] = g_signal_new ("write-pamac-config-finished", PAMAC_TYPE_DAEMON, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
	pamac_daemon_signals[PAMAC_DAEMON_GENERATE_MIRRORS_LIST_DATA_SIGNAL] = g_signal_new ("generate-mirrors-list-data", PAMAC_TYPE_DAEMON, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_STRING, G_TYPE_NONE, 2, G_TYPE_STRING, G_TYPE_STRING);
	pamac_daemon_signals[PAMAC_DAEMON_GENERATE_MIRRORS_LIST_FINISHED_SIGNAL] = g_signal_new ("generate-mirrors-list-finished", PAMAC_TYPE_DAEMON, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
	pamac_daemon_signals[PAMAC_DAEMON_CLEAN_CACHE_FINISHED_SIGNAL] = g_signal_new ("clean-cache-finished", PAMAC_TYPE_DAEMON, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_BOOLEAN, G_TYPE_NONE, 2, G_TYPE_STRING, G_TYPE_BOOLEAN);
	pamac_daemon_signals[PAMAC_DAEMON_CLEAN_BUILD_FILES_FINISHED_SIGNAL] = g_signal_new ("clean-build-files-finished", PAMAC_TYPE_DAEMON, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_BOOLEAN, G_TYPE_NONE, 2, G_TYPE_STRING, G_TYPE_BOOLEAN);
	pamac_daemon_signals[PAMAC_DAEMON_SNAP_TRANS_RUN_FINISHED_SIGNAL] = g_signal_new ("snap-trans-run-finished", PAMAC_TYPE_DAEMON, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_BOOLEAN, G_TYPE_NONE, 2, G_TYPE_STRING, G_TYPE_BOOLEAN);
	pamac_daemon_signals[PAMAC_DAEMON_SNAP_SWITCH_CHANNEL_FINISHED_SIGNAL] = g_signal_new ("snap-switch-channel-finished", PAMAC_TYPE_DAEMON, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_BOOLEAN, G_TYPE_NONE, 2, G_TYPE_STRING, G_TYPE_BOOLEAN);
	pamac_daemon_signals[PAMAC_DAEMON_FLATPAK_TRANS_RUN_FINISHED_SIGNAL] = g_signal_new ("flatpak-trans-run-finished", PAMAC_TYPE_DAEMON, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_BOOLEAN, G_TYPE_NONE, 2, G_TYPE_STRING, G_TYPE_BOOLEAN);
}

static GType
pamac_daemon_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PamacDaemonIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) pamac_daemon_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType pamac_daemon_type_id;
	pamac_daemon_type_id = g_type_register_static (G_TYPE_INTERFACE, "PamacDaemon", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (pamac_daemon_type_id, G_TYPE_OBJECT);
	g_type_set_qdata (pamac_daemon_type_id, g_quark_from_static_string ("vala-dbus-proxy-type"), (void*) pamac_daemon_proxy_get_type);
	g_type_set_qdata (pamac_daemon_type_id, g_quark_from_static_string ("vala-dbus-interface-name"), "org.manjaro.pamac.daemon");
	g_type_set_qdata (pamac_daemon_type_id, g_quark_from_static_string ("vala-dbus-interface-info"), (void*) (&_pamac_daemon_dbus_interface_info));
	g_type_set_qdata (pamac_daemon_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) pamac_daemon_register_object);
	return pamac_daemon_type_id;
}

GType
pamac_daemon_get_type (void)
{
	static volatile gsize pamac_daemon_type_id__once = 0;
	if (g_once_init_enter (&pamac_daemon_type_id__once)) {
		GType pamac_daemon_type_id;
		pamac_daemon_type_id = pamac_daemon_get_type_once ();
		g_once_init_leave (&pamac_daemon_type_id__once, pamac_daemon_type_id);
	}
	return pamac_daemon_type_id__once;
}

G_DEFINE_TYPE_EXTENDED (PamacDaemonProxy, pamac_daemon_proxy, G_TYPE_DBUS_PROXY, 0, G_IMPLEMENT_INTERFACE (PAMAC_TYPE_DAEMON, pamac_daemon_proxy_pamac_daemon_interface_init) )
static void
pamac_daemon_proxy_class_init (PamacDaemonProxyClass* klass)
{
	G_DBUS_PROXY_CLASS (klass)->g_signal = pamac_daemon_proxy_g_signal;
}

static void
_dbus_handle_pamac_daemon_emit_action (PamacDaemon* self,
                                       GVariant* parameters)
{
	GVariantIter _arguments_iter;
	gchar* sender = NULL;
	GVariant* _tmp0_;
	gchar* action = NULL;
	GVariant* _tmp1_;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp0_ = g_variant_iter_next_value (&_arguments_iter);
	sender = g_variant_dup_string (_tmp0_, NULL);
	g_variant_unref (_tmp0_);
	_tmp1_ = g_variant_iter_next_value (&_arguments_iter);
	action = g_variant_dup_string (_tmp1_, NULL);
	g_variant_unref (_tmp1_);
	g_signal_emit_by_name (self, "emit-action", sender, action);
	_g_free0 (sender);
	_g_free0 (action);
}

static void
_dbus_handle_pamac_daemon_emit_action_progress (PamacDaemon* self,
                                                GVariant* parameters)
{
	GVariantIter _arguments_iter;
	gchar* sender = NULL;
	GVariant* _tmp2_;
	gchar* action = NULL;
	GVariant* _tmp3_;
	gchar* status = NULL;
	GVariant* _tmp4_;
	gdouble progress = 0.0;
	GVariant* _tmp5_;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp2_ = g_variant_iter_next_value (&_arguments_iter);
	sender = g_variant_dup_string (_tmp2_, NULL);
	g_variant_unref (_tmp2_);
	_tmp3_ = g_variant_iter_next_value (&_arguments_iter);
	action = g_variant_dup_string (_tmp3_, NULL);
	g_variant_unref (_tmp3_);
	_tmp4_ = g_variant_iter_next_value (&_arguments_iter);
	status = g_variant_dup_string (_tmp4_, NULL);
	g_variant_unref (_tmp4_);
	_tmp5_ = g_variant_iter_next_value (&_arguments_iter);
	progress = g_variant_get_double (_tmp5_);
	g_variant_unref (_tmp5_);
	g_signal_emit_by_name (self, "emit-action-progress", sender, action, status, progress);
	_g_free0 (sender);
	_g_free0 (action);
	_g_free0 (status);
}

static void
_dbus_handle_pamac_daemon_emit_download_progress (PamacDaemon* self,
                                                  GVariant* parameters)
{
	GVariantIter _arguments_iter;
	gchar* sender = NULL;
	GVariant* _tmp6_;
	gchar* action = NULL;
	GVariant* _tmp7_;
	gchar* status = NULL;
	GVariant* _tmp8_;
	gdouble progress = 0.0;
	GVariant* _tmp9_;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp6_ = g_variant_iter_next_value (&_arguments_iter);
	sender = g_variant_dup_string (_tmp6_, NULL);
	g_variant_unref (_tmp6_);
	_tmp7_ = g_variant_iter_next_value (&_arguments_iter);
	action = g_variant_dup_string (_tmp7_, NULL);
	g_variant_unref (_tmp7_);
	_tmp8_ = g_variant_iter_next_value (&_arguments_iter);
	status = g_variant_dup_string (_tmp8_, NULL);
	g_variant_unref (_tmp8_);
	_tmp9_ = g_variant_iter_next_value (&_arguments_iter);
	progress = g_variant_get_double (_tmp9_);
	g_variant_unref (_tmp9_);
	g_signal_emit_by_name (self, "emit-download-progress", sender, action, status, progress);
	_g_free0 (sender);
	_g_free0 (action);
	_g_free0 (status);
}

static void
_dbus_handle_pamac_daemon_emit_hook_progress (PamacDaemon* self,
                                              GVariant* parameters)
{
	GVariantIter _arguments_iter;
	gchar* sender = NULL;
	GVariant* _tmp10_;
	gchar* action = NULL;
	GVariant* _tmp11_;
	gchar* details = NULL;
	GVariant* _tmp12_;
	gchar* status = NULL;
	GVariant* _tmp13_;
	gdouble progress = 0.0;
	GVariant* _tmp14_;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp10_ = g_variant_iter_next_value (&_arguments_iter);
	sender = g_variant_dup_string (_tmp10_, NULL);
	g_variant_unref (_tmp10_);
	_tmp11_ = g_variant_iter_next_value (&_arguments_iter);
	action = g_variant_dup_string (_tmp11_, NULL);
	g_variant_unref (_tmp11_);
	_tmp12_ = g_variant_iter_next_value (&_arguments_iter);
	details = g_variant_dup_string (_tmp12_, NULL);
	g_variant_unref (_tmp12_);
	_tmp13_ = g_variant_iter_next_value (&_arguments_iter);
	status = g_variant_dup_string (_tmp13_, NULL);
	g_variant_unref (_tmp13_);
	_tmp14_ = g_variant_iter_next_value (&_arguments_iter);
	progress = g_variant_get_double (_tmp14_);
	g_variant_unref (_tmp14_);
	g_signal_emit_by_name (self, "emit-hook-progress", sender, action, details, status, progress);
	_g_free0 (sender);
	_g_free0 (action);
	_g_free0 (details);
	_g_free0 (status);
}

static void
_dbus_handle_pamac_daemon_emit_script_output (PamacDaemon* self,
                                              GVariant* parameters)
{
	GVariantIter _arguments_iter;
	gchar* sender = NULL;
	GVariant* _tmp15_;
	gchar* message = NULL;
	GVariant* _tmp16_;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp15_ = g_variant_iter_next_value (&_arguments_iter);
	sender = g_variant_dup_string (_tmp15_, NULL);
	g_variant_unref (_tmp15_);
	_tmp16_ = g_variant_iter_next_value (&_arguments_iter);
	message = g_variant_dup_string (_tmp16_, NULL);
	g_variant_unref (_tmp16_);
	g_signal_emit_by_name (self, "emit-script-output", sender, message);
	_g_free0 (sender);
	_g_free0 (message);
}

static void
_dbus_handle_pamac_daemon_emit_warning (PamacDaemon* self,
                                        GVariant* parameters)
{
	GVariantIter _arguments_iter;
	gchar* sender = NULL;
	GVariant* _tmp17_;
	gchar* message = NULL;
	GVariant* _tmp18_;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp17_ = g_variant_iter_next_value (&_arguments_iter);
	sender = g_variant_dup_string (_tmp17_, NULL);
	g_variant_unref (_tmp17_);
	_tmp18_ = g_variant_iter_next_value (&_arguments_iter);
	message = g_variant_dup_string (_tmp18_, NULL);
	g_variant_unref (_tmp18_);
	g_signal_emit_by_name (self, "emit-warning", sender, message);
	_g_free0 (sender);
	_g_free0 (message);
}

static void
_dbus_handle_pamac_daemon_emit_error (PamacDaemon* self,
                                      GVariant* parameters)
{
	GVariantIter _arguments_iter;
	gchar* sender = NULL;
	GVariant* _tmp19_;
	gchar* message = NULL;
	GVariant* _tmp20_;
	gchar** details = NULL;
	gint details_length1;
	GVariant* _tmp21_;
	gchar** _tmp22_;
	gint _tmp22__length;
	gint _tmp22__size;
	gint _tmp22__length1;
	GVariantIter _tmp23_;
	GVariant* _tmp24_;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp19_ = g_variant_iter_next_value (&_arguments_iter);
	sender = g_variant_dup_string (_tmp19_, NULL);
	g_variant_unref (_tmp19_);
	_tmp20_ = g_variant_iter_next_value (&_arguments_iter);
	message = g_variant_dup_string (_tmp20_, NULL);
	g_variant_unref (_tmp20_);
	details_length1 = 0;
	_tmp21_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp22_ = g_new (gchar*, 5);
	_tmp22__length = 0;
	_tmp22__size = 4;
	_tmp22__length1 = 0;
	g_variant_iter_init (&_tmp23_, _tmp21_);
	for (; (_tmp24_ = g_variant_iter_next_value (&_tmp23_)) != NULL; _tmp22__length1++) {
		if (_tmp22__size == _tmp22__length) {
			_tmp22__size = 2 * _tmp22__size;
			_tmp22_ = g_renew (gchar*, _tmp22_, _tmp22__size + 1);
		}
		_tmp22_[_tmp22__length++] = g_variant_dup_string (_tmp24_, NULL);
		g_variant_unref (_tmp24_);
	}
	details_length1 = _tmp22__length1;
	_tmp22_[_tmp22__length] = NULL;
	details = _tmp22_;
	g_variant_unref (_tmp21_);
	g_signal_emit_by_name (self, "emit-error", sender, message, details, details_length1);
	_g_free0 (sender);
	_g_free0 (message);
	details = (_vala_array_free (details, details_length1, (GDestroyNotify) g_free), NULL);
}

static void
_dbus_handle_pamac_daemon_important_details_outpout (PamacDaemon* self,
                                                     GVariant* parameters)
{
	GVariantIter _arguments_iter;
	gchar* sender = NULL;
	GVariant* _tmp25_;
	gboolean must_show = FALSE;
	GVariant* _tmp26_;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp25_ = g_variant_iter_next_value (&_arguments_iter);
	sender = g_variant_dup_string (_tmp25_, NULL);
	g_variant_unref (_tmp25_);
	_tmp26_ = g_variant_iter_next_value (&_arguments_iter);
	must_show = g_variant_get_boolean (_tmp26_);
	g_variant_unref (_tmp26_);
	g_signal_emit_by_name (self, "important-details-outpout", sender, must_show);
	_g_free0 (sender);
}

static void
_dbus_handle_pamac_daemon_start_downloading (PamacDaemon* self,
                                             GVariant* parameters)
{
	GVariantIter _arguments_iter;
	gchar* sender = NULL;
	GVariant* _tmp27_;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp27_ = g_variant_iter_next_value (&_arguments_iter);
	sender = g_variant_dup_string (_tmp27_, NULL);
	g_variant_unref (_tmp27_);
	g_signal_emit_by_name (self, "start-downloading", sender);
	_g_free0 (sender);
}

static void
_dbus_handle_pamac_daemon_stop_downloading (PamacDaemon* self,
                                            GVariant* parameters)
{
	GVariantIter _arguments_iter;
	gchar* sender = NULL;
	GVariant* _tmp28_;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp28_ = g_variant_iter_next_value (&_arguments_iter);
	sender = g_variant_dup_string (_tmp28_, NULL);
	g_variant_unref (_tmp28_);
	g_signal_emit_by_name (self, "stop-downloading", sender);
	_g_free0 (sender);
}

static void
_dbus_handle_pamac_daemon_set_pkgreason_finished (PamacDaemon* self,
                                                  GVariant* parameters)
{
	GVariantIter _arguments_iter;
	gchar* sender = NULL;
	GVariant* _tmp29_;
	gboolean success = FALSE;
	GVariant* _tmp30_;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp29_ = g_variant_iter_next_value (&_arguments_iter);
	sender = g_variant_dup_string (_tmp29_, NULL);
	g_variant_unref (_tmp29_);
	_tmp30_ = g_variant_iter_next_value (&_arguments_iter);
	success = g_variant_get_boolean (_tmp30_);
	g_variant_unref (_tmp30_);
	g_signal_emit_by_name (self, "set-pkgreason-finished", sender, success);
	_g_free0 (sender);
}

static void
_dbus_handle_pamac_daemon_start_waiting (PamacDaemon* self,
                                         GVariant* parameters)
{
	GVariantIter _arguments_iter;
	gchar* sender = NULL;
	GVariant* _tmp31_;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp31_ = g_variant_iter_next_value (&_arguments_iter);
	sender = g_variant_dup_string (_tmp31_, NULL);
	g_variant_unref (_tmp31_);
	g_signal_emit_by_name (self, "start-waiting", sender);
	_g_free0 (sender);
}

static void
_dbus_handle_pamac_daemon_stop_waiting (PamacDaemon* self,
                                        GVariant* parameters)
{
	GVariantIter _arguments_iter;
	gchar* sender = NULL;
	GVariant* _tmp32_;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp32_ = g_variant_iter_next_value (&_arguments_iter);
	sender = g_variant_dup_string (_tmp32_, NULL);
	g_variant_unref (_tmp32_);
	g_signal_emit_by_name (self, "stop-waiting", sender);
	_g_free0 (sender);
}

static void
_dbus_handle_pamac_daemon_download_pkg_finished (PamacDaemon* self,
                                                 GVariant* parameters)
{
	GVariantIter _arguments_iter;
	gchar* sender = NULL;
	GVariant* _tmp33_;
	gchar* path = NULL;
	GVariant* _tmp34_;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp33_ = g_variant_iter_next_value (&_arguments_iter);
	sender = g_variant_dup_string (_tmp33_, NULL);
	g_variant_unref (_tmp33_);
	_tmp34_ = g_variant_iter_next_value (&_arguments_iter);
	path = g_variant_dup_string (_tmp34_, NULL);
	g_variant_unref (_tmp34_);
	g_signal_emit_by_name (self, "download-pkg-finished", sender, path);
	_g_free0 (sender);
	_g_free0 (path);
}

static void
_dbus_handle_pamac_daemon_trans_refresh_finished (PamacDaemon* self,
                                                  GVariant* parameters)
{
	GVariantIter _arguments_iter;
	gchar* sender = NULL;
	GVariant* _tmp35_;
	gboolean success = FALSE;
	GVariant* _tmp36_;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp35_ = g_variant_iter_next_value (&_arguments_iter);
	sender = g_variant_dup_string (_tmp35_, NULL);
	g_variant_unref (_tmp35_);
	_tmp36_ = g_variant_iter_next_value (&_arguments_iter);
	success = g_variant_get_boolean (_tmp36_);
	g_variant_unref (_tmp36_);
	g_signal_emit_by_name (self, "trans-refresh-finished", sender, success);
	_g_free0 (sender);
}

static void
_dbus_handle_pamac_daemon_trans_run_finished (PamacDaemon* self,
                                              GVariant* parameters)
{
	GVariantIter _arguments_iter;
	gchar* sender = NULL;
	GVariant* _tmp37_;
	gboolean success = FALSE;
	GVariant* _tmp38_;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp37_ = g_variant_iter_next_value (&_arguments_iter);
	sender = g_variant_dup_string (_tmp37_, NULL);
	g_variant_unref (_tmp37_);
	_tmp38_ = g_variant_iter_next_value (&_arguments_iter);
	success = g_variant_get_boolean (_tmp38_);
	g_variant_unref (_tmp38_);
	g_signal_emit_by_name (self, "trans-run-finished", sender, success);
	_g_free0 (sender);
}

static void
_dbus_handle_pamac_daemon_download_updates_finished (PamacDaemon* self,
                                                     GVariant* parameters)
{
	GVariantIter _arguments_iter;
	gchar* sender = NULL;
	GVariant* _tmp39_;
	gboolean success = FALSE;
	GVariant* _tmp40_;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp39_ = g_variant_iter_next_value (&_arguments_iter);
	sender = g_variant_dup_string (_tmp39_, NULL);
	g_variant_unref (_tmp39_);
	_tmp40_ = g_variant_iter_next_value (&_arguments_iter);
	success = g_variant_get_boolean (_tmp40_);
	g_variant_unref (_tmp40_);
	g_signal_emit_by_name (self, "download-updates-finished", sender, success);
	_g_free0 (sender);
}

static void
_dbus_handle_pamac_daemon_get_authorization_finished (PamacDaemon* self,
                                                      GVariant* parameters)
{
	GVariantIter _arguments_iter;
	gchar* sender = NULL;
	GVariant* _tmp41_;
	gboolean authorized = FALSE;
	GVariant* _tmp42_;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp41_ = g_variant_iter_next_value (&_arguments_iter);
	sender = g_variant_dup_string (_tmp41_, NULL);
	g_variant_unref (_tmp41_);
	_tmp42_ = g_variant_iter_next_value (&_arguments_iter);
	authorized = g_variant_get_boolean (_tmp42_);
	g_variant_unref (_tmp42_);
	g_signal_emit_by_name (self, "get-authorization-finished", sender, authorized);
	_g_free0 (sender);
}

static void
_dbus_handle_pamac_daemon_write_alpm_config_finished (PamacDaemon* self,
                                                      GVariant* parameters)
{
	GVariantIter _arguments_iter;
	gchar* sender = NULL;
	GVariant* _tmp43_;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp43_ = g_variant_iter_next_value (&_arguments_iter);
	sender = g_variant_dup_string (_tmp43_, NULL);
	g_variant_unref (_tmp43_);
	g_signal_emit_by_name (self, "write-alpm-config-finished", sender);
	_g_free0 (sender);
}

static void
_dbus_handle_pamac_daemon_write_pamac_config_finished (PamacDaemon* self,
                                                       GVariant* parameters)
{
	GVariantIter _arguments_iter;
	gchar* sender = NULL;
	GVariant* _tmp44_;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp44_ = g_variant_iter_next_value (&_arguments_iter);
	sender = g_variant_dup_string (_tmp44_, NULL);
	g_variant_unref (_tmp44_);
	g_signal_emit_by_name (self, "write-pamac-config-finished", sender);
	_g_free0 (sender);
}

static void
_dbus_handle_pamac_daemon_generate_mirrors_list_data (PamacDaemon* self,
                                                      GVariant* parameters)
{
	GVariantIter _arguments_iter;
	gchar* sender = NULL;
	GVariant* _tmp45_;
	gchar* line = NULL;
	GVariant* _tmp46_;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp45_ = g_variant_iter_next_value (&_arguments_iter);
	sender = g_variant_dup_string (_tmp45_, NULL);
	g_variant_unref (_tmp45_);
	_tmp46_ = g_variant_iter_next_value (&_arguments_iter);
	line = g_variant_dup_string (_tmp46_, NULL);
	g_variant_unref (_tmp46_);
	g_signal_emit_by_name (self, "generate-mirrors-list-data", sender, line);
	_g_free0 (sender);
	_g_free0 (line);
}

static void
_dbus_handle_pamac_daemon_generate_mirrors_list_finished (PamacDaemon* self,
                                                          GVariant* parameters)
{
	GVariantIter _arguments_iter;
	gchar* sender = NULL;
	GVariant* _tmp47_;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp47_ = g_variant_iter_next_value (&_arguments_iter);
	sender = g_variant_dup_string (_tmp47_, NULL);
	g_variant_unref (_tmp47_);
	g_signal_emit_by_name (self, "generate-mirrors-list-finished", sender);
	_g_free0 (sender);
}

static void
_dbus_handle_pamac_daemon_clean_cache_finished (PamacDaemon* self,
                                                GVariant* parameters)
{
	GVariantIter _arguments_iter;
	gchar* sender = NULL;
	GVariant* _tmp48_;
	gboolean success = FALSE;
	GVariant* _tmp49_;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp48_ = g_variant_iter_next_value (&_arguments_iter);
	sender = g_variant_dup_string (_tmp48_, NULL);
	g_variant_unref (_tmp48_);
	_tmp49_ = g_variant_iter_next_value (&_arguments_iter);
	success = g_variant_get_boolean (_tmp49_);
	g_variant_unref (_tmp49_);
	g_signal_emit_by_name (self, "clean-cache-finished", sender, success);
	_g_free0 (sender);
}

static void
_dbus_handle_pamac_daemon_clean_build_files_finished (PamacDaemon* self,
                                                      GVariant* parameters)
{
	GVariantIter _arguments_iter;
	gchar* sender = NULL;
	GVariant* _tmp50_;
	gboolean success = FALSE;
	GVariant* _tmp51_;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp50_ = g_variant_iter_next_value (&_arguments_iter);
	sender = g_variant_dup_string (_tmp50_, NULL);
	g_variant_unref (_tmp50_);
	_tmp51_ = g_variant_iter_next_value (&_arguments_iter);
	success = g_variant_get_boolean (_tmp51_);
	g_variant_unref (_tmp51_);
	g_signal_emit_by_name (self, "clean-build-files-finished", sender, success);
	_g_free0 (sender);
}

static void
_dbus_handle_pamac_daemon_snap_trans_run_finished (PamacDaemon* self,
                                                   GVariant* parameters)
{
	GVariantIter _arguments_iter;
	gchar* sender = NULL;
	GVariant* _tmp52_;
	gboolean success = FALSE;
	GVariant* _tmp53_;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp52_ = g_variant_iter_next_value (&_arguments_iter);
	sender = g_variant_dup_string (_tmp52_, NULL);
	g_variant_unref (_tmp52_);
	_tmp53_ = g_variant_iter_next_value (&_arguments_iter);
	success = g_variant_get_boolean (_tmp53_);
	g_variant_unref (_tmp53_);
	g_signal_emit_by_name (self, "snap-trans-run-finished", sender, success);
	_g_free0 (sender);
}

static void
_dbus_handle_pamac_daemon_snap_switch_channel_finished (PamacDaemon* self,
                                                        GVariant* parameters)
{
	GVariantIter _arguments_iter;
	gchar* sender = NULL;
	GVariant* _tmp54_;
	gboolean success = FALSE;
	GVariant* _tmp55_;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp54_ = g_variant_iter_next_value (&_arguments_iter);
	sender = g_variant_dup_string (_tmp54_, NULL);
	g_variant_unref (_tmp54_);
	_tmp55_ = g_variant_iter_next_value (&_arguments_iter);
	success = g_variant_get_boolean (_tmp55_);
	g_variant_unref (_tmp55_);
	g_signal_emit_by_name (self, "snap-switch-channel-finished", sender, success);
	_g_free0 (sender);
}

static void
_dbus_handle_pamac_daemon_flatpak_trans_run_finished (PamacDaemon* self,
                                                      GVariant* parameters)
{
	GVariantIter _arguments_iter;
	gchar* sender = NULL;
	GVariant* _tmp56_;
	gboolean success = FALSE;
	GVariant* _tmp57_;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp56_ = g_variant_iter_next_value (&_arguments_iter);
	sender = g_variant_dup_string (_tmp56_, NULL);
	g_variant_unref (_tmp56_);
	_tmp57_ = g_variant_iter_next_value (&_arguments_iter);
	success = g_variant_get_boolean (_tmp57_);
	g_variant_unref (_tmp57_);
	g_signal_emit_by_name (self, "flatpak-trans-run-finished", sender, success);
	_g_free0 (sender);
}

static void
pamac_daemon_proxy_g_signal (GDBusProxy* proxy,
                             const gchar* sender_name,
                             const gchar* signal_name,
                             GVariant* parameters)
{
	if (strcmp (signal_name, "EmitAction") == 0) {
		_dbus_handle_pamac_daemon_emit_action ((PamacDaemon*) proxy, parameters);
	} else if (strcmp (signal_name, "EmitActionProgress") == 0) {
		_dbus_handle_pamac_daemon_emit_action_progress ((PamacDaemon*) proxy, parameters);
	} else if (strcmp (signal_name, "EmitDownloadProgress") == 0) {
		_dbus_handle_pamac_daemon_emit_download_progress ((PamacDaemon*) proxy, parameters);
	} else if (strcmp (signal_name, "EmitHookProgress") == 0) {
		_dbus_handle_pamac_daemon_emit_hook_progress ((PamacDaemon*) proxy, parameters);
	} else if (strcmp (signal_name, "EmitScriptOutput") == 0) {
		_dbus_handle_pamac_daemon_emit_script_output ((PamacDaemon*) proxy, parameters);
	} else if (strcmp (signal_name, "EmitWarning") == 0) {
		_dbus_handle_pamac_daemon_emit_warning ((PamacDaemon*) proxy, parameters);
	} else if (strcmp (signal_name, "EmitError") == 0) {
		_dbus_handle_pamac_daemon_emit_error ((PamacDaemon*) proxy, parameters);
	} else if (strcmp (signal_name, "ImportantDetailsOutpout") == 0) {
		_dbus_handle_pamac_daemon_important_details_outpout ((PamacDaemon*) proxy, parameters);
	} else if (strcmp (signal_name, "StartDownloading") == 0) {
		_dbus_handle_pamac_daemon_start_downloading ((PamacDaemon*) proxy, parameters);
	} else if (strcmp (signal_name, "StopDownloading") == 0) {
		_dbus_handle_pamac_daemon_stop_downloading ((PamacDaemon*) proxy, parameters);
	} else if (strcmp (signal_name, "SetPkgreasonFinished") == 0) {
		_dbus_handle_pamac_daemon_set_pkgreason_finished ((PamacDaemon*) proxy, parameters);
	} else if (strcmp (signal_name, "StartWaiting") == 0) {
		_dbus_handle_pamac_daemon_start_waiting ((PamacDaemon*) proxy, parameters);
	} else if (strcmp (signal_name, "StopWaiting") == 0) {
		_dbus_handle_pamac_daemon_stop_waiting ((PamacDaemon*) proxy, parameters);
	} else if (strcmp (signal_name, "DownloadPkgFinished") == 0) {
		_dbus_handle_pamac_daemon_download_pkg_finished ((PamacDaemon*) proxy, parameters);
	} else if (strcmp (signal_name, "TransRefreshFinished") == 0) {
		_dbus_handle_pamac_daemon_trans_refresh_finished ((PamacDaemon*) proxy, parameters);
	} else if (strcmp (signal_name, "TransRunFinished") == 0) {
		_dbus_handle_pamac_daemon_trans_run_finished ((PamacDaemon*) proxy, parameters);
	} else if (strcmp (signal_name, "DownloadUpdatesFinished") == 0) {
		_dbus_handle_pamac_daemon_download_updates_finished ((PamacDaemon*) proxy, parameters);
	} else if (strcmp (signal_name, "GetAuthorizationFinished") == 0) {
		_dbus_handle_pamac_daemon_get_authorization_finished ((PamacDaemon*) proxy, parameters);
	} else if (strcmp (signal_name, "WriteAlpmConfigFinished") == 0) {
		_dbus_handle_pamac_daemon_write_alpm_config_finished ((PamacDaemon*) proxy, parameters);
	} else if (strcmp (signal_name, "WritePamacConfigFinished") == 0) {
		_dbus_handle_pamac_daemon_write_pamac_config_finished ((PamacDaemon*) proxy, parameters);
	} else if (strcmp (signal_name, "GenerateMirrorsListData") == 0) {
		_dbus_handle_pamac_daemon_generate_mirrors_list_data ((PamacDaemon*) proxy, parameters);
	} else if (strcmp (signal_name, "GenerateMirrorsListFinished") == 0) {
		_dbus_handle_pamac_daemon_generate_mirrors_list_finished ((PamacDaemon*) proxy, parameters);
	} else if (strcmp (signal_name, "CleanCacheFinished") == 0) {
		_dbus_handle_pamac_daemon_clean_cache_finished ((PamacDaemon*) proxy, parameters);
	} else if (strcmp (signal_name, "CleanBuildFilesFinished") == 0) {
		_dbus_handle_pamac_daemon_clean_build_files_finished ((PamacDaemon*) proxy, parameters);
	} else if (strcmp (signal_name, "SnapTransRunFinished") == 0) {
		_dbus_handle_pamac_daemon_snap_trans_run_finished ((PamacDaemon*) proxy, parameters);
	} else if (strcmp (signal_name, "SnapSwitchChannelFinished") == 0) {
		_dbus_handle_pamac_daemon_snap_switch_channel_finished ((PamacDaemon*) proxy, parameters);
	} else if (strcmp (signal_name, "FlatpakTransRunFinished") == 0) {
		_dbus_handle_pamac_daemon_flatpak_trans_run_finished ((PamacDaemon*) proxy, parameters);
	}
}

static void
pamac_daemon_proxy_init (PamacDaemonProxy* self)
{
	g_dbus_proxy_set_interface_info (G_DBUS_PROXY (self), (GDBusInterfaceInfo *) (&_pamac_daemon_dbus_interface_info));
}

static gchar*
pamac_daemon_proxy_get_sender (PamacDaemon* self,
                               GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	gchar* _result = NULL;
	GVariant* _tmp58_;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.manjaro.pamac.daemon", "GetSender");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return NULL;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return NULL;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp58_ = g_variant_iter_next_value (&_reply_iter);
	_result = g_variant_dup_string (_tmp58_, NULL);
	g_variant_unref (_tmp58_);
	g_object_unref (_reply_message);
	return _result;
}

static gchar*
pamac_daemon_proxy_get_lockfile (PamacDaemon* self,
                                 GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	gchar* _result = NULL;
	GVariant* _tmp59_;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.manjaro.pamac.daemon", "GetLockfile");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return NULL;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return NULL;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp59_ = g_variant_iter_next_value (&_reply_iter);
	_result = g_variant_dup_string (_tmp59_, NULL);
	g_variant_unref (_tmp59_);
	g_object_unref (_reply_message);
	return _result;
}

static void
pamac_daemon_proxy_set_environment_variables (PamacDaemon* self,
                                              GHashTable* variables,
                                              GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GVariantBuilder _tmp60_;
	GHashTableIter _tmp61_;
	gpointer _tmp62_;
	gpointer _tmp63_;
	GDBusMessage *_reply_message;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.manjaro.pamac.daemon", "SetEnvironmentVariables");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_hash_table_iter_init (&_tmp61_, variables);
	g_variant_builder_init (&_tmp60_, G_VARIANT_TYPE ("a{ss}"));
	while (g_hash_table_iter_next (&_tmp61_, &_tmp62_, &_tmp63_)) {
		gchar* _key;
		gchar* _value;
		_key = (gchar*) _tmp62_;
		_value = (gchar*) _tmp63_;
		g_variant_builder_add (&_tmp60_, "{?*}", g_variant_new_string (_key), g_variant_new_string (_value));
	}
	g_variant_builder_add_value (&_arguments_builder, g_variant_builder_end (&_tmp60_));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}

static void
pamac_daemon_proxy_start_get_authorization (PamacDaemon* self,
                                            GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.manjaro.pamac.daemon", "StartGetAuthorization");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}

static void
pamac_daemon_proxy_remove_authorization (PamacDaemon* self,
                                         GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.manjaro.pamac.daemon", "RemoveAuthorization");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}

static void
pamac_daemon_proxy_start_write_alpm_config (PamacDaemon* self,
                                            GHashTable* new_alpm_conf,
                                            GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GVariantBuilder _tmp64_;
	GHashTableIter _tmp65_;
	gpointer _tmp66_;
	gpointer _tmp67_;
	GDBusMessage *_reply_message;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.manjaro.pamac.daemon", "StartWriteAlpmConfig");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_hash_table_iter_init (&_tmp65_, new_alpm_conf);
	g_variant_builder_init (&_tmp64_, G_VARIANT_TYPE ("a{sv}"));
	while (g_hash_table_iter_next (&_tmp65_, &_tmp66_, &_tmp67_)) {
		gchar* _key;
		GVariant* _value;
		_key = (gchar*) _tmp66_;
		_value = (GVariant*) _tmp67_;
		g_variant_builder_add (&_tmp64_, "{?*}", g_variant_new_string (_key), g_variant_new_variant (_value));
	}
	g_variant_builder_add_value (&_arguments_builder, g_variant_builder_end (&_tmp64_));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}

static void
pamac_daemon_proxy_start_write_pamac_config (PamacDaemon* self,
                                             GHashTable* new_pamac_conf,
                                             GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GVariantBuilder _tmp68_;
	GHashTableIter _tmp69_;
	gpointer _tmp70_;
	gpointer _tmp71_;
	GDBusMessage *_reply_message;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.manjaro.pamac.daemon", "StartWritePamacConfig");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_hash_table_iter_init (&_tmp69_, new_pamac_conf);
	g_variant_builder_init (&_tmp68_, G_VARIANT_TYPE ("a{sv}"));
	while (g_hash_table_iter_next (&_tmp69_, &_tmp70_, &_tmp71_)) {
		gchar* _key;
		GVariant* _value;
		_key = (gchar*) _tmp70_;
		_value = (GVariant*) _tmp71_;
		g_variant_builder_add (&_tmp68_, "{?*}", g_variant_new_string (_key), g_variant_new_variant (_value));
	}
	g_variant_builder_add_value (&_arguments_builder, g_variant_builder_end (&_tmp68_));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}

static void
pamac_daemon_proxy_start_generate_mirrors_list (PamacDaemon* self,
                                                const gchar* country,
                                                GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.manjaro.pamac.daemon", "StartGenerateMirrorsList");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (country));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}

static void
pamac_daemon_proxy_start_clean_cache (PamacDaemon* self,
                                      gchar** filenames,
                                      gint filenames_length1,
                                      GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	gchar** _tmp72_;
	GVariantBuilder _tmp73_;
	gint _tmp74_;
	GDBusMessage *_reply_message;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.manjaro.pamac.daemon", "StartCleanCache");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_tmp72_ = filenames;
	g_variant_builder_init (&_tmp73_, G_VARIANT_TYPE ("as"));
	for (_tmp74_ = 0; _tmp74_ < filenames_length1; _tmp74_++) {
		g_variant_builder_add_value (&_tmp73_, g_variant_new_string (*_tmp72_));
		_tmp72_++;
	}
	g_variant_builder_add_value (&_arguments_builder, g_variant_builder_end (&_tmp73_));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}

static void
pamac_daemon_proxy_start_clean_build_files (PamacDaemon* self,
                                            const gchar* aur_build_dir,
                                            GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.manjaro.pamac.daemon", "StartCleanBuildFiles");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (aur_build_dir));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}

static void
pamac_daemon_proxy_start_set_pkgreason (PamacDaemon* self,
                                        const gchar* pkgname,
                                        guint reason,
                                        GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.manjaro.pamac.daemon", "StartSetPkgreason");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (pkgname));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (reason));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}

static void
pamac_daemon_proxy_start_download_updates (PamacDaemon* self,
                                           GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.manjaro.pamac.daemon", "StartDownloadUpdates");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}

static void
pamac_daemon_proxy_start_download_pkg (PamacDaemon* self,
                                       const gchar* url,
                                       GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.manjaro.pamac.daemon", "StartDownloadPkg");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (url));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}

static void
pamac_daemon_proxy_start_trans_refresh (PamacDaemon* self,
                                        gboolean force,
                                        GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.manjaro.pamac.daemon", "StartTransRefresh");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_boolean (force));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}

static void
pamac_daemon_proxy_start_trans_run (PamacDaemon* self,
                                    gboolean sysupgrade,
                                    gboolean enable_downgrade,
                                    gboolean simple_install,
                                    gboolean keep_built_pkgs,
                                    gint trans_flags,
                                    gchar** to_install,
                                    gint to_install_length1,
                                    gchar** to_remove,
                                    gint to_remove_length1,
                                    gchar** to_load,
                                    gint to_load_length1,
                                    gchar** to_install_as_dep,
                                    gint to_install_as_dep_length1,
                                    gchar** ignorepkgs,
                                    gint ignorepkgs_length1,
                                    gchar** overwrite_files,
                                    gint overwrite_files_length1,
                                    GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	gchar** _tmp75_;
	GVariantBuilder _tmp76_;
	gint _tmp77_;
	gchar** _tmp78_;
	GVariantBuilder _tmp79_;
	gint _tmp80_;
	gchar** _tmp81_;
	GVariantBuilder _tmp82_;
	gint _tmp83_;
	gchar** _tmp84_;
	GVariantBuilder _tmp85_;
	gint _tmp86_;
	gchar** _tmp87_;
	GVariantBuilder _tmp88_;
	gint _tmp89_;
	gchar** _tmp90_;
	GVariantBuilder _tmp91_;
	gint _tmp92_;
	GDBusMessage *_reply_message;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.manjaro.pamac.daemon", "StartTransRun");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_boolean (sysupgrade));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_boolean (enable_downgrade));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_boolean (simple_install));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_boolean (keep_built_pkgs));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_int32 (trans_flags));
	_tmp75_ = to_install;
	g_variant_builder_init (&_tmp76_, G_VARIANT_TYPE ("as"));
	for (_tmp77_ = 0; _tmp77_ < to_install_length1; _tmp77_++) {
		g_variant_builder_add_value (&_tmp76_, g_variant_new_string (*_tmp75_));
		_tmp75_++;
	}
	g_variant_builder_add_value (&_arguments_builder, g_variant_builder_end (&_tmp76_));
	_tmp78_ = to_remove;
	g_variant_builder_init (&_tmp79_, G_VARIANT_TYPE ("as"));
	for (_tmp80_ = 0; _tmp80_ < to_remove_length1; _tmp80_++) {
		g_variant_builder_add_value (&_tmp79_, g_variant_new_string (*_tmp78_));
		_tmp78_++;
	}
	g_variant_builder_add_value (&_arguments_builder, g_variant_builder_end (&_tmp79_));
	_tmp81_ = to_load;
	g_variant_builder_init (&_tmp82_, G_VARIANT_TYPE ("as"));
	for (_tmp83_ = 0; _tmp83_ < to_load_length1; _tmp83_++) {
		g_variant_builder_add_value (&_tmp82_, g_variant_new_string (*_tmp81_));
		_tmp81_++;
	}
	g_variant_builder_add_value (&_arguments_builder, g_variant_builder_end (&_tmp82_));
	_tmp84_ = to_install_as_dep;
	g_variant_builder_init (&_tmp85_, G_VARIANT_TYPE ("as"));
	for (_tmp86_ = 0; _tmp86_ < to_install_as_dep_length1; _tmp86_++) {
		g_variant_builder_add_value (&_tmp85_, g_variant_new_string (*_tmp84_));
		_tmp84_++;
	}
	g_variant_builder_add_value (&_arguments_builder, g_variant_builder_end (&_tmp85_));
	_tmp87_ = ignorepkgs;
	g_variant_builder_init (&_tmp88_, G_VARIANT_TYPE ("as"));
	for (_tmp89_ = 0; _tmp89_ < ignorepkgs_length1; _tmp89_++) {
		g_variant_builder_add_value (&_tmp88_, g_variant_new_string (*_tmp87_));
		_tmp87_++;
	}
	g_variant_builder_add_value (&_arguments_builder, g_variant_builder_end (&_tmp88_));
	_tmp90_ = overwrite_files;
	g_variant_builder_init (&_tmp91_, G_VARIANT_TYPE ("as"));
	for (_tmp92_ = 0; _tmp92_ < overwrite_files_length1; _tmp92_++) {
		g_variant_builder_add_value (&_tmp91_, g_variant_new_string (*_tmp90_));
		_tmp90_++;
	}
	g_variant_builder_add_value (&_arguments_builder, g_variant_builder_end (&_tmp91_));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}

static void
pamac_daemon_proxy_trans_cancel (PamacDaemon* self,
                                 GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.manjaro.pamac.daemon", "TransCancel");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}

static void
pamac_daemon_proxy_quit (PamacDaemon* self,
                         GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.manjaro.pamac.daemon", "Quit");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	g_dbus_message_set_flags (_message, G_DBUS_MESSAGE_FLAGS_NO_REPLY_EXPECTED);
	g_dbus_connection_send_message (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, error);
	g_object_unref (_message);
}

static void
pamac_daemon_proxy_start_snap_trans_run (PamacDaemon* self,
                                         gchar** to_install,
                                         gint to_install_length1,
                                         gchar** to_remove,
                                         gint to_remove_length1,
                                         GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	gchar** _tmp93_;
	GVariantBuilder _tmp94_;
	gint _tmp95_;
	gchar** _tmp96_;
	GVariantBuilder _tmp97_;
	gint _tmp98_;
	GDBusMessage *_reply_message;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.manjaro.pamac.daemon", "StartSnapTransRun");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_tmp93_ = to_install;
	g_variant_builder_init (&_tmp94_, G_VARIANT_TYPE ("as"));
	for (_tmp95_ = 0; _tmp95_ < to_install_length1; _tmp95_++) {
		g_variant_builder_add_value (&_tmp94_, g_variant_new_string (*_tmp93_));
		_tmp93_++;
	}
	g_variant_builder_add_value (&_arguments_builder, g_variant_builder_end (&_tmp94_));
	_tmp96_ = to_remove;
	g_variant_builder_init (&_tmp97_, G_VARIANT_TYPE ("as"));
	for (_tmp98_ = 0; _tmp98_ < to_remove_length1; _tmp98_++) {
		g_variant_builder_add_value (&_tmp97_, g_variant_new_string (*_tmp96_));
		_tmp96_++;
	}
	g_variant_builder_add_value (&_arguments_builder, g_variant_builder_end (&_tmp97_));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}

static void
pamac_daemon_proxy_start_snap_switch_channel (PamacDaemon* self,
                                              const gchar* snap_name,
                                              const gchar* channel,
                                              GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.manjaro.pamac.daemon", "StartSnapSwitchChannel");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (snap_name));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (channel));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}

static void
pamac_daemon_proxy_start_flatpak_trans_run (PamacDaemon* self,
                                            gchar** to_install,
                                            gint to_install_length1,
                                            gchar** to_remove,
                                            gint to_remove_length1,
                                            gchar** to_upgrade,
                                            gint to_upgrade_length1,
                                            GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	gchar** _tmp99_;
	GVariantBuilder _tmp100_;
	gint _tmp101_;
	gchar** _tmp102_;
	GVariantBuilder _tmp103_;
	gint _tmp104_;
	gchar** _tmp105_;
	GVariantBuilder _tmp106_;
	gint _tmp107_;
	GDBusMessage *_reply_message;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.manjaro.pamac.daemon", "StartFlatpakTransRun");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_tmp99_ = to_install;
	g_variant_builder_init (&_tmp100_, G_VARIANT_TYPE ("as"));
	for (_tmp101_ = 0; _tmp101_ < to_install_length1; _tmp101_++) {
		g_variant_builder_add_value (&_tmp100_, g_variant_new_string (*_tmp99_));
		_tmp99_++;
	}
	g_variant_builder_add_value (&_arguments_builder, g_variant_builder_end (&_tmp100_));
	_tmp102_ = to_remove;
	g_variant_builder_init (&_tmp103_, G_VARIANT_TYPE ("as"));
	for (_tmp104_ = 0; _tmp104_ < to_remove_length1; _tmp104_++) {
		g_variant_builder_add_value (&_tmp103_, g_variant_new_string (*_tmp102_));
		_tmp102_++;
	}
	g_variant_builder_add_value (&_arguments_builder, g_variant_builder_end (&_tmp103_));
	_tmp105_ = to_upgrade;
	g_variant_builder_init (&_tmp106_, G_VARIANT_TYPE ("as"));
	for (_tmp107_ = 0; _tmp107_ < to_upgrade_length1; _tmp107_++) {
		g_variant_builder_add_value (&_tmp106_, g_variant_new_string (*_tmp105_));
		_tmp105_++;
	}
	g_variant_builder_add_value (&_arguments_builder, g_variant_builder_end (&_tmp106_));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}

static void
pamac_daemon_proxy_pamac_daemon_interface_init (PamacDaemonIface* iface)
{
	iface->get_sender = pamac_daemon_proxy_get_sender;
	iface->get_lockfile = pamac_daemon_proxy_get_lockfile;
	iface->set_environment_variables = pamac_daemon_proxy_set_environment_variables;
	iface->start_get_authorization = pamac_daemon_proxy_start_get_authorization;
	iface->remove_authorization = pamac_daemon_proxy_remove_authorization;
	iface->start_write_alpm_config = pamac_daemon_proxy_start_write_alpm_config;
	iface->start_write_pamac_config = pamac_daemon_proxy_start_write_pamac_config;
	iface->start_generate_mirrors_list = pamac_daemon_proxy_start_generate_mirrors_list;
	iface->start_clean_cache = pamac_daemon_proxy_start_clean_cache;
	iface->start_clean_build_files = pamac_daemon_proxy_start_clean_build_files;
	iface->start_set_pkgreason = pamac_daemon_proxy_start_set_pkgreason;
	iface->start_download_updates = pamac_daemon_proxy_start_download_updates;
	iface->start_download_pkg = pamac_daemon_proxy_start_download_pkg;
	iface->start_trans_refresh = pamac_daemon_proxy_start_trans_refresh;
	iface->start_trans_run = pamac_daemon_proxy_start_trans_run;
	iface->trans_cancel = pamac_daemon_proxy_trans_cancel;
	iface->quit = pamac_daemon_proxy_quit;
	iface->start_snap_trans_run = pamac_daemon_proxy_start_snap_trans_run;
	iface->start_snap_switch_channel = pamac_daemon_proxy_start_snap_switch_channel;
	iface->start_flatpak_trans_run = pamac_daemon_proxy_start_flatpak_trans_run;
}

static void
_dbus_pamac_daemon_get_sender (PamacDaemon* self,
                               GVariant* _parameters_,
                               GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gchar* result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	result = pamac_daemon_get_sender (self, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_string (result));
	_g_free0 (result);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}

static void
_dbus_pamac_daemon_get_lockfile (PamacDaemon* self,
                                 GVariant* _parameters_,
                                 GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gchar* result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	result = pamac_daemon_get_lockfile (self, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_string (result));
	_g_free0 (result);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}

static void
_dbus_pamac_daemon_set_environment_variables (PamacDaemon* self,
                                              GVariant* _parameters_,
                                              GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GHashTable* variables = NULL;
	GVariant* _tmp108_;
	GHashTable* _tmp109_;
	GVariantIter _tmp110_;
	GVariant* _tmp111_;
	GVariant* _tmp112_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp108_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp109_ = g_hash_table_new_full (g_str_hash, g_str_equal, g_free, g_free);
	g_variant_iter_init (&_tmp110_, _tmp108_);
	while (g_variant_iter_loop (&_tmp110_, "{?*}", &_tmp111_, &_tmp112_)) {
		g_hash_table_insert (_tmp109_, g_variant_dup_string (_tmp111_, NULL), g_variant_dup_string (_tmp112_, NULL));
	}
	variables = _tmp109_;
	g_variant_unref (_tmp108_);
	pamac_daemon_set_environment_variables (self, variables, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		goto _error;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_error:
	_g_hash_table_unref0 (variables);
	;
}

static void
_dbus_pamac_daemon_start_get_authorization (PamacDaemon* self,
                                            GVariant* _parameters_,
                                            GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	pamac_daemon_start_get_authorization (self, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}

static void
_dbus_pamac_daemon_remove_authorization (PamacDaemon* self,
                                         GVariant* _parameters_,
                                         GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	pamac_daemon_remove_authorization (self, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}

static void
_dbus_pamac_daemon_start_write_alpm_config (PamacDaemon* self,
                                            GVariant* _parameters_,
                                            GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GHashTable* new_alpm_conf = NULL;
	GVariant* _tmp113_;
	GHashTable* _tmp114_;
	GVariantIter _tmp115_;
	GVariant* _tmp116_;
	GVariant* _tmp117_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp113_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp114_ = g_hash_table_new_full (g_str_hash, g_str_equal, g_free, (GDestroyNotify) g_variant_unref);
	g_variant_iter_init (&_tmp115_, _tmp113_);
	while (g_variant_iter_loop (&_tmp115_, "{?*}", &_tmp116_, &_tmp117_)) {
		g_hash_table_insert (_tmp114_, g_variant_dup_string (_tmp116_, NULL), g_variant_get_variant (_tmp117_));
	}
	new_alpm_conf = _tmp114_;
	g_variant_unref (_tmp113_);
	pamac_daemon_start_write_alpm_config (self, new_alpm_conf, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		goto _error;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_error:
	_g_hash_table_unref0 (new_alpm_conf);
	;
}

static void
_dbus_pamac_daemon_start_write_pamac_config (PamacDaemon* self,
                                             GVariant* _parameters_,
                                             GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GHashTable* new_pamac_conf = NULL;
	GVariant* _tmp118_;
	GHashTable* _tmp119_;
	GVariantIter _tmp120_;
	GVariant* _tmp121_;
	GVariant* _tmp122_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp118_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp119_ = g_hash_table_new_full (g_str_hash, g_str_equal, g_free, (GDestroyNotify) g_variant_unref);
	g_variant_iter_init (&_tmp120_, _tmp118_);
	while (g_variant_iter_loop (&_tmp120_, "{?*}", &_tmp121_, &_tmp122_)) {
		g_hash_table_insert (_tmp119_, g_variant_dup_string (_tmp121_, NULL), g_variant_get_variant (_tmp122_));
	}
	new_pamac_conf = _tmp119_;
	g_variant_unref (_tmp118_);
	pamac_daemon_start_write_pamac_config (self, new_pamac_conf, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		goto _error;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_error:
	_g_hash_table_unref0 (new_pamac_conf);
	;
}

static void
_dbus_pamac_daemon_start_generate_mirrors_list (PamacDaemon* self,
                                                GVariant* _parameters_,
                                                GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* country = NULL;
	GVariant* _tmp123_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp123_ = g_variant_iter_next_value (&_arguments_iter);
	country = g_variant_dup_string (_tmp123_, NULL);
	g_variant_unref (_tmp123_);
	pamac_daemon_start_generate_mirrors_list (self, country, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		goto _error;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_error:
	_g_free0 (country);
	;
}

static void
_dbus_pamac_daemon_start_clean_cache (PamacDaemon* self,
                                      GVariant* _parameters_,
                                      GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar** filenames = NULL;
	gint filenames_length1 = 0;
	GVariant* _tmp124_;
	gchar** _tmp125_;
	gint _tmp125__length;
	gint _tmp125__size;
	gint _tmp125__length1;
	GVariantIter _tmp126_;
	GVariant* _tmp127_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp124_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp125_ = g_new (gchar*, 5);
	_tmp125__length = 0;
	_tmp125__size = 4;
	_tmp125__length1 = 0;
	g_variant_iter_init (&_tmp126_, _tmp124_);
	for (; (_tmp127_ = g_variant_iter_next_value (&_tmp126_)) != NULL; _tmp125__length1++) {
		if (_tmp125__size == _tmp125__length) {
			_tmp125__size = 2 * _tmp125__size;
			_tmp125_ = g_renew (gchar*, _tmp125_, _tmp125__size + 1);
		}
		_tmp125_[_tmp125__length++] = g_variant_dup_string (_tmp127_, NULL);
		g_variant_unref (_tmp127_);
	}
	filenames_length1 = _tmp125__length1;
	_tmp125_[_tmp125__length] = NULL;
	filenames = _tmp125_;
	g_variant_unref (_tmp124_);
	pamac_daemon_start_clean_cache (self, filenames, filenames_length1, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		goto _error;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_error:
	filenames = (_vala_array_free (filenames, filenames_length1, (GDestroyNotify) g_free), NULL);
	;
}

static void
_dbus_pamac_daemon_start_clean_build_files (PamacDaemon* self,
                                            GVariant* _parameters_,
                                            GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* aur_build_dir = NULL;
	GVariant* _tmp128_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp128_ = g_variant_iter_next_value (&_arguments_iter);
	aur_build_dir = g_variant_dup_string (_tmp128_, NULL);
	g_variant_unref (_tmp128_);
	pamac_daemon_start_clean_build_files (self, aur_build_dir, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		goto _error;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_error:
	_g_free0 (aur_build_dir);
	;
}

static void
_dbus_pamac_daemon_start_set_pkgreason (PamacDaemon* self,
                                        GVariant* _parameters_,
                                        GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* pkgname = NULL;
	GVariant* _tmp129_;
	guint reason = 0U;
	GVariant* _tmp130_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp129_ = g_variant_iter_next_value (&_arguments_iter);
	pkgname = g_variant_dup_string (_tmp129_, NULL);
	g_variant_unref (_tmp129_);
	_tmp130_ = g_variant_iter_next_value (&_arguments_iter);
	reason = g_variant_get_uint32 (_tmp130_);
	g_variant_unref (_tmp130_);
	pamac_daemon_start_set_pkgreason (self, pkgname, reason, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		goto _error;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_error:
	_g_free0 (pkgname);
	;
}

static void
_dbus_pamac_daemon_start_download_updates (PamacDaemon* self,
                                           GVariant* _parameters_,
                                           GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	pamac_daemon_start_download_updates (self, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}

static void
_dbus_pamac_daemon_start_download_pkg (PamacDaemon* self,
                                       GVariant* _parameters_,
                                       GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* url = NULL;
	GVariant* _tmp131_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp131_ = g_variant_iter_next_value (&_arguments_iter);
	url = g_variant_dup_string (_tmp131_, NULL);
	g_variant_unref (_tmp131_);
	pamac_daemon_start_download_pkg (self, url, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		goto _error;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_error:
	_g_free0 (url);
	;
}

static void
_dbus_pamac_daemon_start_trans_refresh (PamacDaemon* self,
                                        GVariant* _parameters_,
                                        GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gboolean force = FALSE;
	GVariant* _tmp132_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp132_ = g_variant_iter_next_value (&_arguments_iter);
	force = g_variant_get_boolean (_tmp132_);
	g_variant_unref (_tmp132_);
	pamac_daemon_start_trans_refresh (self, force, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}

static void
_dbus_pamac_daemon_start_trans_run (PamacDaemon* self,
                                    GVariant* _parameters_,
                                    GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gboolean sysupgrade = FALSE;
	GVariant* _tmp133_;
	gboolean enable_downgrade = FALSE;
	GVariant* _tmp134_;
	gboolean simple_install = FALSE;
	GVariant* _tmp135_;
	gboolean keep_built_pkgs = FALSE;
	GVariant* _tmp136_;
	gint trans_flags = 0;
	GVariant* _tmp137_;
	gchar** to_install = NULL;
	gint to_install_length1 = 0;
	GVariant* _tmp138_;
	gchar** _tmp139_;
	gint _tmp139__length;
	gint _tmp139__size;
	gint _tmp139__length1;
	GVariantIter _tmp140_;
	GVariant* _tmp141_;
	gchar** to_remove = NULL;
	gint to_remove_length1 = 0;
	GVariant* _tmp142_;
	gchar** _tmp143_;
	gint _tmp143__length;
	gint _tmp143__size;
	gint _tmp143__length1;
	GVariantIter _tmp144_;
	GVariant* _tmp145_;
	gchar** to_load = NULL;
	gint to_load_length1 = 0;
	GVariant* _tmp146_;
	gchar** _tmp147_;
	gint _tmp147__length;
	gint _tmp147__size;
	gint _tmp147__length1;
	GVariantIter _tmp148_;
	GVariant* _tmp149_;
	gchar** to_install_as_dep = NULL;
	gint to_install_as_dep_length1 = 0;
	GVariant* _tmp150_;
	gchar** _tmp151_;
	gint _tmp151__length;
	gint _tmp151__size;
	gint _tmp151__length1;
	GVariantIter _tmp152_;
	GVariant* _tmp153_;
	gchar** ignorepkgs = NULL;
	gint ignorepkgs_length1 = 0;
	GVariant* _tmp154_;
	gchar** _tmp155_;
	gint _tmp155__length;
	gint _tmp155__size;
	gint _tmp155__length1;
	GVariantIter _tmp156_;
	GVariant* _tmp157_;
	gchar** overwrite_files = NULL;
	gint overwrite_files_length1 = 0;
	GVariant* _tmp158_;
	gchar** _tmp159_;
	gint _tmp159__length;
	gint _tmp159__size;
	gint _tmp159__length1;
	GVariantIter _tmp160_;
	GVariant* _tmp161_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp133_ = g_variant_iter_next_value (&_arguments_iter);
	sysupgrade = g_variant_get_boolean (_tmp133_);
	g_variant_unref (_tmp133_);
	_tmp134_ = g_variant_iter_next_value (&_arguments_iter);
	enable_downgrade = g_variant_get_boolean (_tmp134_);
	g_variant_unref (_tmp134_);
	_tmp135_ = g_variant_iter_next_value (&_arguments_iter);
	simple_install = g_variant_get_boolean (_tmp135_);
	g_variant_unref (_tmp135_);
	_tmp136_ = g_variant_iter_next_value (&_arguments_iter);
	keep_built_pkgs = g_variant_get_boolean (_tmp136_);
	g_variant_unref (_tmp136_);
	_tmp137_ = g_variant_iter_next_value (&_arguments_iter);
	trans_flags = g_variant_get_int32 (_tmp137_);
	g_variant_unref (_tmp137_);
	_tmp138_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp139_ = g_new (gchar*, 5);
	_tmp139__length = 0;
	_tmp139__size = 4;
	_tmp139__length1 = 0;
	g_variant_iter_init (&_tmp140_, _tmp138_);
	for (; (_tmp141_ = g_variant_iter_next_value (&_tmp140_)) != NULL; _tmp139__length1++) {
		if (_tmp139__size == _tmp139__length) {
			_tmp139__size = 2 * _tmp139__size;
			_tmp139_ = g_renew (gchar*, _tmp139_, _tmp139__size + 1);
		}
		_tmp139_[_tmp139__length++] = g_variant_dup_string (_tmp141_, NULL);
		g_variant_unref (_tmp141_);
	}
	to_install_length1 = _tmp139__length1;
	_tmp139_[_tmp139__length] = NULL;
	to_install = _tmp139_;
	g_variant_unref (_tmp138_);
	_tmp142_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp143_ = g_new (gchar*, 5);
	_tmp143__length = 0;
	_tmp143__size = 4;
	_tmp143__length1 = 0;
	g_variant_iter_init (&_tmp144_, _tmp142_);
	for (; (_tmp145_ = g_variant_iter_next_value (&_tmp144_)) != NULL; _tmp143__length1++) {
		if (_tmp143__size == _tmp143__length) {
			_tmp143__size = 2 * _tmp143__size;
			_tmp143_ = g_renew (gchar*, _tmp143_, _tmp143__size + 1);
		}
		_tmp143_[_tmp143__length++] = g_variant_dup_string (_tmp145_, NULL);
		g_variant_unref (_tmp145_);
	}
	to_remove_length1 = _tmp143__length1;
	_tmp143_[_tmp143__length] = NULL;
	to_remove = _tmp143_;
	g_variant_unref (_tmp142_);
	_tmp146_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp147_ = g_new (gchar*, 5);
	_tmp147__length = 0;
	_tmp147__size = 4;
	_tmp147__length1 = 0;
	g_variant_iter_init (&_tmp148_, _tmp146_);
	for (; (_tmp149_ = g_variant_iter_next_value (&_tmp148_)) != NULL; _tmp147__length1++) {
		if (_tmp147__size == _tmp147__length) {
			_tmp147__size = 2 * _tmp147__size;
			_tmp147_ = g_renew (gchar*, _tmp147_, _tmp147__size + 1);
		}
		_tmp147_[_tmp147__length++] = g_variant_dup_string (_tmp149_, NULL);
		g_variant_unref (_tmp149_);
	}
	to_load_length1 = _tmp147__length1;
	_tmp147_[_tmp147__length] = NULL;
	to_load = _tmp147_;
	g_variant_unref (_tmp146_);
	_tmp150_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp151_ = g_new (gchar*, 5);
	_tmp151__length = 0;
	_tmp151__size = 4;
	_tmp151__length1 = 0;
	g_variant_iter_init (&_tmp152_, _tmp150_);
	for (; (_tmp153_ = g_variant_iter_next_value (&_tmp152_)) != NULL; _tmp151__length1++) {
		if (_tmp151__size == _tmp151__length) {
			_tmp151__size = 2 * _tmp151__size;
			_tmp151_ = g_renew (gchar*, _tmp151_, _tmp151__size + 1);
		}
		_tmp151_[_tmp151__length++] = g_variant_dup_string (_tmp153_, NULL);
		g_variant_unref (_tmp153_);
	}
	to_install_as_dep_length1 = _tmp151__length1;
	_tmp151_[_tmp151__length] = NULL;
	to_install_as_dep = _tmp151_;
	g_variant_unref (_tmp150_);
	_tmp154_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp155_ = g_new (gchar*, 5);
	_tmp155__length = 0;
	_tmp155__size = 4;
	_tmp155__length1 = 0;
	g_variant_iter_init (&_tmp156_, _tmp154_);
	for (; (_tmp157_ = g_variant_iter_next_value (&_tmp156_)) != NULL; _tmp155__length1++) {
		if (_tmp155__size == _tmp155__length) {
			_tmp155__size = 2 * _tmp155__size;
			_tmp155_ = g_renew (gchar*, _tmp155_, _tmp155__size + 1);
		}
		_tmp155_[_tmp155__length++] = g_variant_dup_string (_tmp157_, NULL);
		g_variant_unref (_tmp157_);
	}
	ignorepkgs_length1 = _tmp155__length1;
	_tmp155_[_tmp155__length] = NULL;
	ignorepkgs = _tmp155_;
	g_variant_unref (_tmp154_);
	_tmp158_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp159_ = g_new (gchar*, 5);
	_tmp159__length = 0;
	_tmp159__size = 4;
	_tmp159__length1 = 0;
	g_variant_iter_init (&_tmp160_, _tmp158_);
	for (; (_tmp161_ = g_variant_iter_next_value (&_tmp160_)) != NULL; _tmp159__length1++) {
		if (_tmp159__size == _tmp159__length) {
			_tmp159__size = 2 * _tmp159__size;
			_tmp159_ = g_renew (gchar*, _tmp159_, _tmp159__size + 1);
		}
		_tmp159_[_tmp159__length++] = g_variant_dup_string (_tmp161_, NULL);
		g_variant_unref (_tmp161_);
	}
	overwrite_files_length1 = _tmp159__length1;
	_tmp159_[_tmp159__length] = NULL;
	overwrite_files = _tmp159_;
	g_variant_unref (_tmp158_);
	pamac_daemon_start_trans_run (self, sysupgrade, enable_downgrade, simple_install, keep_built_pkgs, trans_flags, to_install, to_install_length1, to_remove, to_remove_length1, to_load, to_load_length1, to_install_as_dep, to_install_as_dep_length1, ignorepkgs, ignorepkgs_length1, overwrite_files, overwrite_files_length1, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		goto _error;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_error:
	to_install = (_vala_array_free (to_install, to_install_length1, (GDestroyNotify) g_free), NULL);
	to_remove = (_vala_array_free (to_remove, to_remove_length1, (GDestroyNotify) g_free), NULL);
	to_load = (_vala_array_free (to_load, to_load_length1, (GDestroyNotify) g_free), NULL);
	to_install_as_dep = (_vala_array_free (to_install_as_dep, to_install_as_dep_length1, (GDestroyNotify) g_free), NULL);
	ignorepkgs = (_vala_array_free (ignorepkgs, ignorepkgs_length1, (GDestroyNotify) g_free), NULL);
	overwrite_files = (_vala_array_free (overwrite_files, overwrite_files_length1, (GDestroyNotify) g_free), NULL);
	;
}

static void
_dbus_pamac_daemon_trans_cancel (PamacDaemon* self,
                                 GVariant* _parameters_,
                                 GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	pamac_daemon_trans_cancel (self, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}

static void
_dbus_pamac_daemon_quit (PamacDaemon* self,
                         GVariant* _parameters_,
                         GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	pamac_daemon_quit (self, &error);
}

static void
_dbus_pamac_daemon_start_snap_trans_run (PamacDaemon* self,
                                         GVariant* _parameters_,
                                         GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar** to_install = NULL;
	gint to_install_length1 = 0;
	GVariant* _tmp162_;
	gchar** _tmp163_;
	gint _tmp163__length;
	gint _tmp163__size;
	gint _tmp163__length1;
	GVariantIter _tmp164_;
	GVariant* _tmp165_;
	gchar** to_remove = NULL;
	gint to_remove_length1 = 0;
	GVariant* _tmp166_;
	gchar** _tmp167_;
	gint _tmp167__length;
	gint _tmp167__size;
	gint _tmp167__length1;
	GVariantIter _tmp168_;
	GVariant* _tmp169_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp162_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp163_ = g_new (gchar*, 5);
	_tmp163__length = 0;
	_tmp163__size = 4;
	_tmp163__length1 = 0;
	g_variant_iter_init (&_tmp164_, _tmp162_);
	for (; (_tmp165_ = g_variant_iter_next_value (&_tmp164_)) != NULL; _tmp163__length1++) {
		if (_tmp163__size == _tmp163__length) {
			_tmp163__size = 2 * _tmp163__size;
			_tmp163_ = g_renew (gchar*, _tmp163_, _tmp163__size + 1);
		}
		_tmp163_[_tmp163__length++] = g_variant_dup_string (_tmp165_, NULL);
		g_variant_unref (_tmp165_);
	}
	to_install_length1 = _tmp163__length1;
	_tmp163_[_tmp163__length] = NULL;
	to_install = _tmp163_;
	g_variant_unref (_tmp162_);
	_tmp166_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp167_ = g_new (gchar*, 5);
	_tmp167__length = 0;
	_tmp167__size = 4;
	_tmp167__length1 = 0;
	g_variant_iter_init (&_tmp168_, _tmp166_);
	for (; (_tmp169_ = g_variant_iter_next_value (&_tmp168_)) != NULL; _tmp167__length1++) {
		if (_tmp167__size == _tmp167__length) {
			_tmp167__size = 2 * _tmp167__size;
			_tmp167_ = g_renew (gchar*, _tmp167_, _tmp167__size + 1);
		}
		_tmp167_[_tmp167__length++] = g_variant_dup_string (_tmp169_, NULL);
		g_variant_unref (_tmp169_);
	}
	to_remove_length1 = _tmp167__length1;
	_tmp167_[_tmp167__length] = NULL;
	to_remove = _tmp167_;
	g_variant_unref (_tmp166_);
	pamac_daemon_start_snap_trans_run (self, to_install, to_install_length1, to_remove, to_remove_length1, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		goto _error;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_error:
	to_install = (_vala_array_free (to_install, to_install_length1, (GDestroyNotify) g_free), NULL);
	to_remove = (_vala_array_free (to_remove, to_remove_length1, (GDestroyNotify) g_free), NULL);
	;
}

static void
_dbus_pamac_daemon_start_snap_switch_channel (PamacDaemon* self,
                                              GVariant* _parameters_,
                                              GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* snap_name = NULL;
	GVariant* _tmp170_;
	gchar* channel = NULL;
	GVariant* _tmp171_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp170_ = g_variant_iter_next_value (&_arguments_iter);
	snap_name = g_variant_dup_string (_tmp170_, NULL);
	g_variant_unref (_tmp170_);
	_tmp171_ = g_variant_iter_next_value (&_arguments_iter);
	channel = g_variant_dup_string (_tmp171_, NULL);
	g_variant_unref (_tmp171_);
	pamac_daemon_start_snap_switch_channel (self, snap_name, channel, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		goto _error;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_error:
	_g_free0 (snap_name);
	_g_free0 (channel);
	;
}

static void
_dbus_pamac_daemon_start_flatpak_trans_run (PamacDaemon* self,
                                            GVariant* _parameters_,
                                            GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar** to_install = NULL;
	gint to_install_length1 = 0;
	GVariant* _tmp172_;
	gchar** _tmp173_;
	gint _tmp173__length;
	gint _tmp173__size;
	gint _tmp173__length1;
	GVariantIter _tmp174_;
	GVariant* _tmp175_;
	gchar** to_remove = NULL;
	gint to_remove_length1 = 0;
	GVariant* _tmp176_;
	gchar** _tmp177_;
	gint _tmp177__length;
	gint _tmp177__size;
	gint _tmp177__length1;
	GVariantIter _tmp178_;
	GVariant* _tmp179_;
	gchar** to_upgrade = NULL;
	gint to_upgrade_length1 = 0;
	GVariant* _tmp180_;
	gchar** _tmp181_;
	gint _tmp181__length;
	gint _tmp181__size;
	gint _tmp181__length1;
	GVariantIter _tmp182_;
	GVariant* _tmp183_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp172_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp173_ = g_new (gchar*, 5);
	_tmp173__length = 0;
	_tmp173__size = 4;
	_tmp173__length1 = 0;
	g_variant_iter_init (&_tmp174_, _tmp172_);
	for (; (_tmp175_ = g_variant_iter_next_value (&_tmp174_)) != NULL; _tmp173__length1++) {
		if (_tmp173__size == _tmp173__length) {
			_tmp173__size = 2 * _tmp173__size;
			_tmp173_ = g_renew (gchar*, _tmp173_, _tmp173__size + 1);
		}
		_tmp173_[_tmp173__length++] = g_variant_dup_string (_tmp175_, NULL);
		g_variant_unref (_tmp175_);
	}
	to_install_length1 = _tmp173__length1;
	_tmp173_[_tmp173__length] = NULL;
	to_install = _tmp173_;
	g_variant_unref (_tmp172_);
	_tmp176_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp177_ = g_new (gchar*, 5);
	_tmp177__length = 0;
	_tmp177__size = 4;
	_tmp177__length1 = 0;
	g_variant_iter_init (&_tmp178_, _tmp176_);
	for (; (_tmp179_ = g_variant_iter_next_value (&_tmp178_)) != NULL; _tmp177__length1++) {
		if (_tmp177__size == _tmp177__length) {
			_tmp177__size = 2 * _tmp177__size;
			_tmp177_ = g_renew (gchar*, _tmp177_, _tmp177__size + 1);
		}
		_tmp177_[_tmp177__length++] = g_variant_dup_string (_tmp179_, NULL);
		g_variant_unref (_tmp179_);
	}
	to_remove_length1 = _tmp177__length1;
	_tmp177_[_tmp177__length] = NULL;
	to_remove = _tmp177_;
	g_variant_unref (_tmp176_);
	_tmp180_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp181_ = g_new (gchar*, 5);
	_tmp181__length = 0;
	_tmp181__size = 4;
	_tmp181__length1 = 0;
	g_variant_iter_init (&_tmp182_, _tmp180_);
	for (; (_tmp183_ = g_variant_iter_next_value (&_tmp182_)) != NULL; _tmp181__length1++) {
		if (_tmp181__size == _tmp181__length) {
			_tmp181__size = 2 * _tmp181__size;
			_tmp181_ = g_renew (gchar*, _tmp181_, _tmp181__size + 1);
		}
		_tmp181_[_tmp181__length++] = g_variant_dup_string (_tmp183_, NULL);
		g_variant_unref (_tmp183_);
	}
	to_upgrade_length1 = _tmp181__length1;
	_tmp181_[_tmp181__length] = NULL;
	to_upgrade = _tmp181_;
	g_variant_unref (_tmp180_);
	pamac_daemon_start_flatpak_trans_run (self, to_install, to_install_length1, to_remove, to_remove_length1, to_upgrade, to_upgrade_length1, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		goto _error;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_error:
	to_install = (_vala_array_free (to_install, to_install_length1, (GDestroyNotify) g_free), NULL);
	to_remove = (_vala_array_free (to_remove, to_remove_length1, (GDestroyNotify) g_free), NULL);
	to_upgrade = (_vala_array_free (to_upgrade, to_upgrade_length1, (GDestroyNotify) g_free), NULL);
	;
}

static void
pamac_daemon_dbus_interface_method_call (GDBusConnection* connection,
                                         const gchar* sender,
                                         const gchar* object_path,
                                         const gchar* interface_name,
                                         const gchar* method_name,
                                         GVariant* parameters,
                                         GDBusMethodInvocation* invocation,
                                         gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (method_name, "GetSender") == 0) {
		_dbus_pamac_daemon_get_sender (object, parameters, invocation);
	} else if (strcmp (method_name, "GetLockfile") == 0) {
		_dbus_pamac_daemon_get_lockfile (object, parameters, invocation);
	} else if (strcmp (method_name, "SetEnvironmentVariables") == 0) {
		_dbus_pamac_daemon_set_environment_variables (object, parameters, invocation);
	} else if (strcmp (method_name, "StartGetAuthorization") == 0) {
		_dbus_pamac_daemon_start_get_authorization (object, parameters, invocation);
	} else if (strcmp (method_name, "RemoveAuthorization") == 0) {
		_dbus_pamac_daemon_remove_authorization (object, parameters, invocation);
	} else if (strcmp (method_name, "StartWriteAlpmConfig") == 0) {
		_dbus_pamac_daemon_start_write_alpm_config (object, parameters, invocation);
	} else if (strcmp (method_name, "StartWritePamacConfig") == 0) {
		_dbus_pamac_daemon_start_write_pamac_config (object, parameters, invocation);
	} else if (strcmp (method_name, "StartGenerateMirrorsList") == 0) {
		_dbus_pamac_daemon_start_generate_mirrors_list (object, parameters, invocation);
	} else if (strcmp (method_name, "StartCleanCache") == 0) {
		_dbus_pamac_daemon_start_clean_cache (object, parameters, invocation);
	} else if (strcmp (method_name, "StartCleanBuildFiles") == 0) {
		_dbus_pamac_daemon_start_clean_build_files (object, parameters, invocation);
	} else if (strcmp (method_name, "StartSetPkgreason") == 0) {
		_dbus_pamac_daemon_start_set_pkgreason (object, parameters, invocation);
	} else if (strcmp (method_name, "StartDownloadUpdates") == 0) {
		_dbus_pamac_daemon_start_download_updates (object, parameters, invocation);
	} else if (strcmp (method_name, "StartDownloadPkg") == 0) {
		_dbus_pamac_daemon_start_download_pkg (object, parameters, invocation);
	} else if (strcmp (method_name, "StartTransRefresh") == 0) {
		_dbus_pamac_daemon_start_trans_refresh (object, parameters, invocation);
	} else if (strcmp (method_name, "StartTransRun") == 0) {
		_dbus_pamac_daemon_start_trans_run (object, parameters, invocation);
	} else if (strcmp (method_name, "TransCancel") == 0) {
		_dbus_pamac_daemon_trans_cancel (object, parameters, invocation);
	} else if (strcmp (method_name, "Quit") == 0) {
		_dbus_pamac_daemon_quit (object, parameters, invocation);
	} else if (strcmp (method_name, "StartSnapTransRun") == 0) {
		_dbus_pamac_daemon_start_snap_trans_run (object, parameters, invocation);
	} else if (strcmp (method_name, "StartSnapSwitchChannel") == 0) {
		_dbus_pamac_daemon_start_snap_switch_channel (object, parameters, invocation);
	} else if (strcmp (method_name, "StartFlatpakTransRun") == 0) {
		_dbus_pamac_daemon_start_flatpak_trans_run (object, parameters, invocation);
	} else {
		g_object_unref (invocation);
	}
}

static GVariant*
pamac_daemon_dbus_interface_get_property (GDBusConnection* connection,
                                          const gchar* sender,
                                          const gchar* object_path,
                                          const gchar* interface_name,
                                          const gchar* property_name,
                                          GError** error,
                                          gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return NULL;
}

static gboolean
pamac_daemon_dbus_interface_set_property (GDBusConnection* connection,
                                          const gchar* sender,
                                          const gchar* object_path,
                                          const gchar* interface_name,
                                          const gchar* property_name,
                                          GVariant* value,
                                          GError** error,
                                          gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return FALSE;
}

static void
_dbus_pamac_daemon_emit_action (GObject* _sender,
                                const gchar* sender,
                                const gchar* action,
                                gpointer* _data)
{
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (sender));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (action));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.manjaro.pamac.daemon", "EmitAction", _arguments, NULL);
}

static void
_dbus_pamac_daemon_emit_action_progress (GObject* _sender,
                                         const gchar* sender,
                                         const gchar* action,
                                         const gchar* status,
                                         gdouble progress,
                                         gpointer* _data)
{
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (sender));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (action));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (status));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_double (progress));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.manjaro.pamac.daemon", "EmitActionProgress", _arguments, NULL);
}

static void
_dbus_pamac_daemon_emit_download_progress (GObject* _sender,
                                           const gchar* sender,
                                           const gchar* action,
                                           const gchar* status,
                                           gdouble progress,
                                           gpointer* _data)
{
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (sender));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (action));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (status));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_double (progress));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.manjaro.pamac.daemon", "EmitDownloadProgress", _arguments, NULL);
}

static void
_dbus_pamac_daemon_emit_hook_progress (GObject* _sender,
                                       const gchar* sender,
                                       const gchar* action,
                                       const gchar* details,
                                       const gchar* status,
                                       gdouble progress,
                                       gpointer* _data)
{
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (sender));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (action));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (details));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (status));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_double (progress));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.manjaro.pamac.daemon", "EmitHookProgress", _arguments, NULL);
}

static void
_dbus_pamac_daemon_emit_script_output (GObject* _sender,
                                       const gchar* sender,
                                       const gchar* message,
                                       gpointer* _data)
{
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (sender));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (message));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.manjaro.pamac.daemon", "EmitScriptOutput", _arguments, NULL);
}

static void
_dbus_pamac_daemon_emit_warning (GObject* _sender,
                                 const gchar* sender,
                                 const gchar* message,
                                 gpointer* _data)
{
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (sender));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (message));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.manjaro.pamac.daemon", "EmitWarning", _arguments, NULL);
}

static void
_dbus_pamac_daemon_emit_error (GObject* _sender,
                               const gchar* sender,
                               const gchar* message,
                               gchar** details,
                               gint details_length1,
                               gpointer* _data)
{
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	gchar** _tmp184_;
	GVariantBuilder _tmp185_;
	gint _tmp186_;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (sender));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (message));
	_tmp184_ = details;
	g_variant_builder_init (&_tmp185_, G_VARIANT_TYPE ("as"));
	for (_tmp186_ = 0; _tmp186_ < details_length1; _tmp186_++) {
		g_variant_builder_add_value (&_tmp185_, g_variant_new_string (*_tmp184_));
		_tmp184_++;
	}
	g_variant_builder_add_value (&_arguments_builder, g_variant_builder_end (&_tmp185_));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.manjaro.pamac.daemon", "EmitError", _arguments, NULL);
}

static void
_dbus_pamac_daemon_important_details_outpout (GObject* _sender,
                                              const gchar* sender,
                                              gboolean must_show,
                                              gpointer* _data)
{
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (sender));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_boolean (must_show));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.manjaro.pamac.daemon", "ImportantDetailsOutpout", _arguments, NULL);
}

static void
_dbus_pamac_daemon_start_downloading (GObject* _sender,
                                      const gchar* sender,
                                      gpointer* _data)
{
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (sender));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.manjaro.pamac.daemon", "StartDownloading", _arguments, NULL);
}

static void
_dbus_pamac_daemon_stop_downloading (GObject* _sender,
                                     const gchar* sender,
                                     gpointer* _data)
{
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (sender));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.manjaro.pamac.daemon", "StopDownloading", _arguments, NULL);
}

static void
_dbus_pamac_daemon_set_pkgreason_finished (GObject* _sender,
                                           const gchar* sender,
                                           gboolean success,
                                           gpointer* _data)
{
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (sender));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_boolean (success));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.manjaro.pamac.daemon", "SetPkgreasonFinished", _arguments, NULL);
}

static void
_dbus_pamac_daemon_start_waiting (GObject* _sender,
                                  const gchar* sender,
                                  gpointer* _data)
{
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (sender));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.manjaro.pamac.daemon", "StartWaiting", _arguments, NULL);
}

static void
_dbus_pamac_daemon_stop_waiting (GObject* _sender,
                                 const gchar* sender,
                                 gpointer* _data)
{
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (sender));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.manjaro.pamac.daemon", "StopWaiting", _arguments, NULL);
}

static void
_dbus_pamac_daemon_download_pkg_finished (GObject* _sender,
                                          const gchar* sender,
                                          const gchar* path,
                                          gpointer* _data)
{
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (sender));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (path));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.manjaro.pamac.daemon", "DownloadPkgFinished", _arguments, NULL);
}

static void
_dbus_pamac_daemon_trans_refresh_finished (GObject* _sender,
                                           const gchar* sender,
                                           gboolean success,
                                           gpointer* _data)
{
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (sender));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_boolean (success));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.manjaro.pamac.daemon", "TransRefreshFinished", _arguments, NULL);
}

static void
_dbus_pamac_daemon_trans_run_finished (GObject* _sender,
                                       const gchar* sender,
                                       gboolean success,
                                       gpointer* _data)
{
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (sender));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_boolean (success));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.manjaro.pamac.daemon", "TransRunFinished", _arguments, NULL);
}

static void
_dbus_pamac_daemon_download_updates_finished (GObject* _sender,
                                              const gchar* sender,
                                              gboolean success,
                                              gpointer* _data)
{
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (sender));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_boolean (success));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.manjaro.pamac.daemon", "DownloadUpdatesFinished", _arguments, NULL);
}

static void
_dbus_pamac_daemon_get_authorization_finished (GObject* _sender,
                                               const gchar* sender,
                                               gboolean authorized,
                                               gpointer* _data)
{
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (sender));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_boolean (authorized));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.manjaro.pamac.daemon", "GetAuthorizationFinished", _arguments, NULL);
}

static void
_dbus_pamac_daemon_write_alpm_config_finished (GObject* _sender,
                                               const gchar* sender,
                                               gpointer* _data)
{
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (sender));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.manjaro.pamac.daemon", "WriteAlpmConfigFinished", _arguments, NULL);
}

static void
_dbus_pamac_daemon_write_pamac_config_finished (GObject* _sender,
                                                const gchar* sender,
                                                gpointer* _data)
{
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (sender));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.manjaro.pamac.daemon", "WritePamacConfigFinished", _arguments, NULL);
}

static void
_dbus_pamac_daemon_generate_mirrors_list_data (GObject* _sender,
                                               const gchar* sender,
                                               const gchar* line,
                                               gpointer* _data)
{
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (sender));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (line));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.manjaro.pamac.daemon", "GenerateMirrorsListData", _arguments, NULL);
}

static void
_dbus_pamac_daemon_generate_mirrors_list_finished (GObject* _sender,
                                                   const gchar* sender,
                                                   gpointer* _data)
{
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (sender));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.manjaro.pamac.daemon", "GenerateMirrorsListFinished", _arguments, NULL);
}

static void
_dbus_pamac_daemon_clean_cache_finished (GObject* _sender,
                                         const gchar* sender,
                                         gboolean success,
                                         gpointer* _data)
{
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (sender));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_boolean (success));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.manjaro.pamac.daemon", "CleanCacheFinished", _arguments, NULL);
}

static void
_dbus_pamac_daemon_clean_build_files_finished (GObject* _sender,
                                               const gchar* sender,
                                               gboolean success,
                                               gpointer* _data)
{
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (sender));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_boolean (success));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.manjaro.pamac.daemon", "CleanBuildFilesFinished", _arguments, NULL);
}

static void
_dbus_pamac_daemon_snap_trans_run_finished (GObject* _sender,
                                            const gchar* sender,
                                            gboolean success,
                                            gpointer* _data)
{
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (sender));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_boolean (success));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.manjaro.pamac.daemon", "SnapTransRunFinished", _arguments, NULL);
}

static void
_dbus_pamac_daemon_snap_switch_channel_finished (GObject* _sender,
                                                 const gchar* sender,
                                                 gboolean success,
                                                 gpointer* _data)
{
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (sender));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_boolean (success));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.manjaro.pamac.daemon", "SnapSwitchChannelFinished", _arguments, NULL);
}

static void
_dbus_pamac_daemon_flatpak_trans_run_finished (GObject* _sender,
                                               const gchar* sender,
                                               gboolean success,
                                               gpointer* _data)
{
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (sender));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_boolean (success));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.manjaro.pamac.daemon", "FlatpakTransRunFinished", _arguments, NULL);
}

guint
pamac_daemon_register_object (gpointer object,
                              GDBusConnection* connection,
                              const gchar* path,
                              GError** error)
{
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = g_object_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_pamac_daemon_dbus_interface_info), &_pamac_daemon_dbus_interface_vtable, data, _pamac_daemon_unregister_object, error);
	if (!result) {
		return 0;
	}
	g_signal_connect (object, "emit-action", (GCallback) _dbus_pamac_daemon_emit_action, data);
	g_signal_connect (object, "emit-action-progress", (GCallback) _dbus_pamac_daemon_emit_action_progress, data);
	g_signal_connect (object, "emit-download-progress", (GCallback) _dbus_pamac_daemon_emit_download_progress, data);
	g_signal_connect (object, "emit-hook-progress", (GCallback) _dbus_pamac_daemon_emit_hook_progress, data);
	g_signal_connect (object, "emit-script-output", (GCallback) _dbus_pamac_daemon_emit_script_output, data);
	g_signal_connect (object, "emit-warning", (GCallback) _dbus_pamac_daemon_emit_warning, data);
	g_signal_connect (object, "emit-error", (GCallback) _dbus_pamac_daemon_emit_error, data);
	g_signal_connect (object, "important-details-outpout", (GCallback) _dbus_pamac_daemon_important_details_outpout, data);
	g_signal_connect (object, "start-downloading", (GCallback) _dbus_pamac_daemon_start_downloading, data);
	g_signal_connect (object, "stop-downloading", (GCallback) _dbus_pamac_daemon_stop_downloading, data);
	g_signal_connect (object, "set-pkgreason-finished", (GCallback) _dbus_pamac_daemon_set_pkgreason_finished, data);
	g_signal_connect (object, "start-waiting", (GCallback) _dbus_pamac_daemon_start_waiting, data);
	g_signal_connect (object, "stop-waiting", (GCallback) _dbus_pamac_daemon_stop_waiting, data);
	g_signal_connect (object, "download-pkg-finished", (GCallback) _dbus_pamac_daemon_download_pkg_finished, data);
	g_signal_connect (object, "trans-refresh-finished", (GCallback) _dbus_pamac_daemon_trans_refresh_finished, data);
	g_signal_connect (object, "trans-run-finished", (GCallback) _dbus_pamac_daemon_trans_run_finished, data);
	g_signal_connect (object, "download-updates-finished", (GCallback) _dbus_pamac_daemon_download_updates_finished, data);
	g_signal_connect (object, "get-authorization-finished", (GCallback) _dbus_pamac_daemon_get_authorization_finished, data);
	g_signal_connect (object, "write-alpm-config-finished", (GCallback) _dbus_pamac_daemon_write_alpm_config_finished, data);
	g_signal_connect (object, "write-pamac-config-finished", (GCallback) _dbus_pamac_daemon_write_pamac_config_finished, data);
	g_signal_connect (object, "generate-mirrors-list-data", (GCallback) _dbus_pamac_daemon_generate_mirrors_list_data, data);
	g_signal_connect (object, "generate-mirrors-list-finished", (GCallback) _dbus_pamac_daemon_generate_mirrors_list_finished, data);
	g_signal_connect (object, "clean-cache-finished", (GCallback) _dbus_pamac_daemon_clean_cache_finished, data);
	g_signal_connect (object, "clean-build-files-finished", (GCallback) _dbus_pamac_daemon_clean_build_files_finished, data);
	g_signal_connect (object, "snap-trans-run-finished", (GCallback) _dbus_pamac_daemon_snap_trans_run_finished, data);
	g_signal_connect (object, "snap-switch-channel-finished", (GCallback) _dbus_pamac_daemon_snap_switch_channel_finished, data);
	g_signal_connect (object, "flatpak-trans-run-finished", (GCallback) _dbus_pamac_daemon_flatpak_trans_run_finished, data);
	return result;
}

static void
_pamac_daemon_unregister_object (gpointer user_data)
{
	gpointer* data;
	data = user_data;
	g_signal_handlers_disconnect_by_func (data[0], _dbus_pamac_daemon_emit_action, data);
	g_signal_handlers_disconnect_by_func (data[0], _dbus_pamac_daemon_emit_action_progress, data);
	g_signal_handlers_disconnect_by_func (data[0], _dbus_pamac_daemon_emit_download_progress, data);
	g_signal_handlers_disconnect_by_func (data[0], _dbus_pamac_daemon_emit_hook_progress, data);
	g_signal_handlers_disconnect_by_func (data[0], _dbus_pamac_daemon_emit_script_output, data);
	g_signal_handlers_disconnect_by_func (data[0], _dbus_pamac_daemon_emit_warning, data);
	g_signal_handlers_disconnect_by_func (data[0], _dbus_pamac_daemon_emit_error, data);
	g_signal_handlers_disconnect_by_func (data[0], _dbus_pamac_daemon_important_details_outpout, data);
	g_signal_handlers_disconnect_by_func (data[0], _dbus_pamac_daemon_start_downloading, data);
	g_signal_handlers_disconnect_by_func (data[0], _dbus_pamac_daemon_stop_downloading, data);
	g_signal_handlers_disconnect_by_func (data[0], _dbus_pamac_daemon_set_pkgreason_finished, data);
	g_signal_handlers_disconnect_by_func (data[0], _dbus_pamac_daemon_start_waiting, data);
	g_signal_handlers_disconnect_by_func (data[0], _dbus_pamac_daemon_stop_waiting, data);
	g_signal_handlers_disconnect_by_func (data[0], _dbus_pamac_daemon_download_pkg_finished, data);
	g_signal_handlers_disconnect_by_func (data[0], _dbus_pamac_daemon_trans_refresh_finished, data);
	g_signal_handlers_disconnect_by_func (data[0], _dbus_pamac_daemon_trans_run_finished, data);
	g_signal_handlers_disconnect_by_func (data[0], _dbus_pamac_daemon_download_updates_finished, data);
	g_signal_handlers_disconnect_by_func (data[0], _dbus_pamac_daemon_get_authorization_finished, data);
	g_signal_handlers_disconnect_by_func (data[0], _dbus_pamac_daemon_write_alpm_config_finished, data);
	g_signal_handlers_disconnect_by_func (data[0], _dbus_pamac_daemon_write_pamac_config_finished, data);
	g_signal_handlers_disconnect_by_func (data[0], _dbus_pamac_daemon_generate_mirrors_list_data, data);
	g_signal_handlers_disconnect_by_func (data[0], _dbus_pamac_daemon_generate_mirrors_list_finished, data);
	g_signal_handlers_disconnect_by_func (data[0], _dbus_pamac_daemon_clean_cache_finished, data);
	g_signal_handlers_disconnect_by_func (data[0], _dbus_pamac_daemon_clean_build_files_finished, data);
	g_signal_handlers_disconnect_by_func (data[0], _dbus_pamac_daemon_snap_trans_run_finished, data);
	g_signal_handlers_disconnect_by_func (data[0], _dbus_pamac_daemon_snap_switch_channel_finished, data);
	g_signal_handlers_disconnect_by_func (data[0], _dbus_pamac_daemon_flatpak_trans_run_finished, data);
	g_object_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

